#include "command.h"
#include "shaza.h"
/*************************************************************************************/
void add_loci_errors_n(nloci,base,isim,terror,n)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* adds errors to simulate match's in data */
/*************************************************************************************/
int nloci;     /* number of loci */
int base;      /* 1 use:    allele number as loci identification */
               /* 0         allele number as defined from 1..n   */
int isim;      /* 0 change: animal_data[] using allele frequencies read in from data OR */
               /* 1         animal_sim[]  to simulate recaptures found                  */
double terror; /* proportional typing error */
int n;         /* record to be modified */
{

  int kk,i,jj;
  double xx;

  for(i=0; i <nloci; i++)             /* for i loci    */
  {
     if(drand() < terror)             /* only do for typing error rate */
     {
       jj=randchoice();               /* random choice of haploid allele     */
       xx=drand();
       for(kk=0; kk < loc[i].n; kk++) /* for all alleles in loci i */
       if(xx <= loc[i].cfreq[kk])     /* sample new allele from allele frequency within loci i */
       {
          if(isim)
          {
            if(base) animal_sim[n][i][jj]=loc[i].allele[kk];    /* use actual allele number */
            else     animal_sim[n][i][jj]=(kk+1);               /* number alleles from 1..n */
          }
          else
          {
            if(base) animal_data[n][i][jj]=loc[i].allele[kk];   /* use actual allele number */
            else     animal_data[n][i][jj]=(kk+1);              /* number alleles from 1..n */
          }

          kk=loc[i].n;  /* exit kk loop for this loci */
       }  
     }
  }
}


