#include "shaza.h"
/*************************************************************************************/
int binarySearch(double sortedArray[], int first, int last, double x)
/* coded by: Michael Macbeth et al.      revision - 5/10/2009     */
/*************************************************************************************/
{
   /* function:
      Searches sortedArray[first]..sortedArray[last] for key.
    returns: index of the matching element if it finds key,
            otherwise  -(index where it could be inserted)-1.
    parameters:
      sortedArray in  array of sorted (ascending) values.
      first, last in  lower and upper subscript bounds
      key         in  value to search for.
    returns:
      index of key, or -insertion_position -1 if key is not
                    in the array. This value can easily be
                    transformed into the position to insert it.  */
   int mid;

   if(x >= sortedArray[0] ) return(0);
   if(x <= sortedArray[last]) return (-1);  /* too small to put in top array class */

   while (first <= last) 
   {
       mid = (first + last) / 2;  /* compute mid point.   */
       if (x < sortedArray[mid])
       {
           first = mid + 1;  /* repeat search in top half. */
       }
       else if (x > sortedArray[mid])
       {
           last = mid - 1; /* repeat search in bottom half.   */
       }
       else return(mid);     /* found it. return position */
   }
   return  (first);   /* entry position   */
    
}




