#include "command.h"
#include "shaza.h"
/*************************************************************************************/
int bitperm(mbit,add,clear,type)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* Record combinations of missing loci in string                                     */
/*************************************************************************************/
unsigned int mbit;
int add;    /* count if missing value read in data */
int clear;  /* do not clear iperm if clear = 0 */
char type; /* ' ' missing value found in data */
           /* 'a' missing value added to enable additional comparisons of samples with missing loci */
           /* 'e' missing value added to search for errors */
           /* 's' simulated missing value  */
{
   static int iperm=0;
   int i,found;
   
   if(clear)
   {
     iperm=0;  /* reset for new block combination */
     return(0);
   }

   if(iperm == 0)     /* record first combination here */
   {
      if(add) perm[iperm].n=1; /* count frequency of combinations */
      perm[iperm].type=type;
      perm[iperm++].bit=mbit;

   }
   else
   {
      found=0;
      /* check if similar to any combinations recorded so far */
      /* todo: for large number of perms could sort and do binary search */
      /*       for most applications this may not be too inefficient     */
      for(i=0 ; i < iperm; i++)
      if(perm[i].bit == mbit )
      {
         found=1;         /* found this combination */
         if(add) perm[i].n=perm[i].n+1; /* count frequency        */
      }

      if(!found)     /* new combination        */
      {
         if(add) perm[iperm].n=1;
         else    perm[iperm].n=0;
         perm[iperm].type=type;

         perm[iperm++].bit=mbit;
         
         if(iperm > PERM)
         {
            fprintf(fp7,"Maximum number of missing value combinations %d has exceeded PERM=%d.\n",iperm,PERM);
            fprintf(fp7,"Need to increase PERM.\n");
            fprintf(fp7,"Program stopped due to condition above\n");

            fprintf(stdout,"\nMaximum number of missing value combinations %d has exceeded PERM=%d.\n",iperm,PERM);
            fprintf(stdout,"Need to increase PERM.\n");
            fprintf(stdout,"Program stopped due to condition above\n");
            exit(1);
         }
      }
   }

   return(iperm);
}

