#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void check_dim()
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* checks dimensions of input parameters */
/*************************************************************************************/
{
   if(n_MAX > LOOP_SFZ)
   {
       fprintf(fp7,"\n(n_MAX=%d) must be <= (LOOP_SFZ=%d)  \n",n_MAX,LOOP_SFZ);
       fprintf(fp7,"     n_MAX    defined in command.h\n");
       fprintf(fp7,"     LOOP_SFZ defined in shaza.h\n");
       fprintf(stdout,"\n\n(n_MAX=%d) must be <= (LOOP_SFZ=%d)  \n",n_MAX,LOOP_SFZ);
       fprintf(stdout,"     n_MAX    defined in command.h\n");
       fprintf(stdout,"     LOOP_SFZ defined in shaza.h\n");
       exit(1);
   }

   if((H_option)&&(M_option))
   if((H_value+M_value) > ANIM)
   {
       fprintf(fp7,"\n[-M NUM]+[-G NUM] must be <= %d  \n",ANIM);
       fprintf(stdout,"\n[-M NUM]+[-G NUM] must be <= %d  \n",ANIM);
       exit(1);
   }

   if(ANIM != M_MAX )
   {
       fprintf(fp7,"\nANIM=%d in shaza.h must be equal to M_MAX=%d in command.h\n",ANIM,M_MAX);
       fprintf(stdout,"\nANIM=%d in shaza.h must be equal to M_MAX=%d in command.h\n",ANIM,M_MAX);
       exit(1);
   }

   if(NOL > (sizeof(int)*8) )
   {
       fprintf(fp7,"\nNumber of loci must be <= %lu as missing loci are stored in bitwise int \n",sizeof(int)*8);
       fprintf(fp7,"To increase the number of loci can use \"long long int\" which on Linux PC's is 64 bits long\n");
       fprintf(fp7,"Borland compiler did not have \"long long int\" but can compile using gcc under MINGW32\n");
       fprintf(fp7,"TODO: Need to change loci combination storage to \"long long int\" and test the 64 bit storage\n");

       fprintf(stdout,"\nNumber of loci must be <= %lu as missing loci are stored in bitwise int \n",sizeof(int)*8);
       fprintf(stdout,"To increase the number of loci can use \"long long int\" which on Linux PC's is 64 bits long\n");
       fprintf(stdout,"Borland compiler did not have \"long long int\" but can compile using gcc under MINGW32\n");
       fprintf(stdout,"TODO: Need to change loci combination storage to \"long long int\" and test the 64 bit storage\n");
       exit(1);
   }

   if(ANIM > 92682)
   {
       fprintf(fp7,"\nANIM must be less than 92682 to avoid overflow in 4 byte unsigned int\n");
       fprintf(fp7,"\nmax unsigned int = 4294967295 and X(X-1)/2=4294930221 where X= 92682 \n");
       fprintf(fp7,"sizeof(int)=%lu bytes \n",sizeof(int));
       fprintf(fp7,"To increase the number of animals can use \"long long int\" which on Linux PC's is 8 bytes long\n");
       fprintf(fp7,"Borland compiler did not have \"long long int\"\n");

       fprintf(stdout,"\nANIM must be less than 92682 to avoid overflow in 4 byte unsigned int\n");
       fprintf(stdout,"\nmax unsigned int = 4294967295 and X(X-1)/2=4294930221 where X= 92682 \n");
       fprintf(stdout,"sizeof(int)=%lu bytes \n",sizeof(int));
       fprintf(stdout,"To increase the number of animals can use \"long long int\" which on Linux PC's is 8 bytes long\n");
       fprintf(stdout,"Borland compiler did not have \"long long int\"\n");
       exit(1);
   }


   if((i_option[0])&&(!i_option[1])) {} /* alleles read from input file */
   else
   if(R_value)  /* if simulating recapture animals AND generated unique animal data from allele frequencies */
   {
      if(!H_value) { /* OK will simulate R_value animals in block A */ }
      else if(R_value > (H_value))
      {
         fprintf(fp7,"\nNoticed you are simulating data from allele frequencies with R_value=%d M_value=%d H_value=%d\n",R_value,M_value,H_value);
         fprintf(fp7,"\nYou can set H_value must be greater than R_value \n");
         fprintf(fp7,"\nAppologies but the program will now exit to allow corrections to be made\n");

         fprintf(stdout,"\nNoticed you are simulating data from allele frequencies with R_value=%d M_value=%d H_value=%d\n",R_value,M_value,H_value);
         fprintf(stdout,"\nYou can set H_value must be greater than R_value \n");
         fprintf(stdout,"\nAppologies but the program will now exit to allow corrections to be made\n");
         exit(1);
      }
   }
}



