#include "command.h"



int  check_arguments();
int  err_msg();
void duplicate_option();

/* command line interpretor for the SHAZA program */
int command_line(argc,argv,program)
char **argv[];
int  *argc;
char *program;
/* Macbeth 18/11/2009 */
/* Macbeth 18/07/2010 added ability to read second int for M, T and E args */
{

  int not_error=1;
  int i, rc=0;
  int model;

  /*external*******************************/
  /* ARG_NUM list    Set defaults */

  b_option=0;        b_value=b_DEFAULT;
  c_option=0;        c_value=c_DEFAULT; 
  e_option=0;        e_value=e_DEFAULT;  
  m_option=0;        m_value=m_DEFAULT;
  n_option=0;        n_value=n_DEFAULT;
  r_option=0;        r_value=r_DEFAULT;
  s_option=0;        s_value=s_DEFAULT;  
  z_option=0;        z_value=z_DEFAULT;  

  R_option=0;        R_value=R_DEFAULT;
  E_option=0;        E_value=e_DEFAULT;  
  M_option=0;        M_value=M_DEFAULT;
  Y_option=0;        Y_value=Y_DEFAULT;
  H_option=0;        H_value=H_DEFAULT;


  /* ARG_STR list    Set defaults */
                     /* Assign value in memory          Then point to it */
  d_option=0;        strcpy(Xd_value,d_DEFAULT);        d_value=(char *)Xd_value;
  k_option=0;        strcpy(Xk_value,k_DEFAULT);        k_value=(char *)Xk_value;

  for(i=0; i<MAX_i; i++)
      i_option[i]=0;

  /* ARG_NON list */
  f_option=0;
  j_option=0;
  p_option=0;
  w_option=0;
  /****************************************/


  /* process runtime arguments */
  if((rc=get_command_line(program,ARG_NUM,ARG_STR,ARG_NON,argc,argv)) == 0)
  {
    shaza_usage(program);
    exit(1);
  }
  else
  {

    /* set parameters */
    for(i=1; strcmp((*argv)[i],OPTEND); i++)
    {
      switch((*argv)[i][1])
      {
      /* ARG_NUM list */

        case 'b':
          if(b_option) duplicate_option((*argv)[i][1],program);
          b_option=1;
          b_value=atoi((*argv)[++i]);
          break;
        case 'c':
          if(c_option) duplicate_option((*argv)[i][1],program);
          c_option=1;
          c_value=atoi((*argv)[++i]);
          break;
        case 'E':
          if(E_option) duplicate_option((*argv)[i][1],program);
          E_option=1;
          E_value=(int)(10000*atof((*argv)[++i])+0.00001);
          break;

        case 'e':
          if(e_option) duplicate_option((*argv)[i][1],program);
          e_option=1;
          e_value=(int)(10000*atof((*argv)[++i])+0.00001);
          break;
        case 'H':
          if(H_option) duplicate_option((*argv)[i][1],program);
          H_option=1;
          H_value=atoi((*argv)[++i]);
          break;
        case 'm':
          if(m_option) duplicate_option((*argv)[i][1],program);
          m_option=1;
          m_value=atoi((*argv)[++i]);
          break;
        case 'M':
          if(M_option) duplicate_option((*argv)[i][1],program);
          M_option=1;
          M_value=atoi((*argv)[++i]);
          break;
        case 'n':
          if(n_option) duplicate_option((*argv)[i][1],program);
          n_option=1;
          n_value=atoi((*argv)[++i]);
          break;

        case 'r':
          if(r_option) duplicate_option((*argv)[i][1],program);
          r_option=1;
          r_value=atoi((*argv)[++i]);
          break;
        case 'R':
          if(R_option) duplicate_option((*argv)[i][1],program);
          R_option=1;
          R_value=atoi((*argv)[++i]);
          break;
        case 's':
          if(s_option) duplicate_option((*argv)[i][1],program);
          s_option=1;
          s_value=atoi((*argv)[++i]);
          break;
        case 'T':
          fprintf(stdout,"Option -T in version 1 has been replaced by option -Y in version 1.10\n");
          fprintf(stdout,"Option -T is backward compatible in this version.\n");
          if(Y_option) duplicate_option((*argv)[i][1],program);
          Y_option=1;
          Y_value=(int)(100*atof((*argv)[++i])+0.00001);  /* added 0.00001 to avoid int conversion truncating by 1 */
          break;
        case 'Y':
          if(Y_option) duplicate_option((*argv)[i][1],program);
          Y_option=1;
          Y_value=(int)(100*atof((*argv)[++i])+0.00001);  /* added 0.00001 to avoid int conversion truncating by 1 */
          break;
        case 'z':
          if(z_option) duplicate_option((*argv)[i][1],program);
          z_option=1;
          z_value=atoi((*argv)[++i])-1; /* internal storage from zero not one */
          break;

        /* ARG_STR list */
        case 'd':
          if(d_option) duplicate_option((*argv)[i][1],program);
          d_option=1;
          d_value=(*argv)[++i];
          break;
        case '1':    /* input FILE 1 */
          if(i_option[0]) duplicate_option((*argv)[i][1],program);
          i_option[0]=1;
          i_value[0]=(*argv)[++i];
          break;
        case '2':    /* input FILE 2 */
          if(i_option[1]) duplicate_option((*argv)[i][1],program);
          i_option[1]=1;
          i_value[1]=(*argv)[++i];
          break;
        case 'k':
          if(k_option) duplicate_option((*argv)[i][1],program);
          k_option=1;
          k_value=(*argv)[++i];
          break;


        /* ARG_NON list  */
        case 'j':
          if(j_option) duplicate_option((*argv)[i][1],program);
          j_option=1;
          break;
        case 'f':
          if(f_option) duplicate_option((*argv)[i][1],program);
          f_option=1;
          break;
        case 'p':
          if(p_option) duplicate_option((*argv)[i][1],program);
          p_option=1;
          break;
        case 'w':
          if(w_option) duplicate_option((*argv)[i][1],program);
          w_option=1;
          break;

        default:
          fprintf(stdout,"Oh Gosh! Unrecognised option on command line (%c)\n", (*argv)[i][1]);
          fprintf(stdout,"arg  <%s>\n", (*argv)[i]);
          exit(1); 
          break;
      }
    }

    if(!E_option) E_value=e_value;
    if(n_value == 1000) z_value++;

    if((model=check_var()))  /* check combinations of command line variables (returns 0 if error found) */
    {
      /* now check range etc of args */
      if(!(not_error=check_arguments(program)))
      {
        shaza_usage(program);
      }
      else
      {
    
        /* create file output names */
        strcpy(o_default[0],d_value);   strcat(o_default[0],o_FILE_0);
        strcpy(o_default[1],d_value);   strcat(o_default[1],o_FILE_1);
        strcpy(o_default[2],d_value);   strcat(o_default[2],o_FILE_2);
        strcpy(o_default[3],d_value);   strcat(o_default[3],o_FILE_3);
        strcpy(o_default[4],d_value);   strcat(o_default[4],o_FILE_4);
        strcpy(o_default[5],d_value);   strcat(o_default[5],o_FILE_5);
        strcpy(o_default[6],d_value);   strcat(o_default[6],o_FILE_6);
        strcpy(o_default[7],d_value);   strcat(o_default[7],o_FILE_7);
        strcpy(o_default[8],d_value);   strcat(o_default[8],o_FILE_8);
        for(i=0; i<MAX_o; i++)
        {
          o_value[i]=(char *)o_default[i];
          if(d_option) o_option[i]=1;
          else         o_option[i]=0;
        }
      }
    }
    else
    {
       shaza_usage(program);
    }



  }


  if(not_error) return(model);
  else          return(0);

}

/**************************************************************/
void duplicate_option(char_opt,program)
/**************************************************************/
char char_opt;
char program[BUFSIZ];
{
  fprintf(stdout,"\n\nDuplicate option -%c found on command line\nPlease check and run %s again\n\n",char_opt,program);
  shaza_usage(program);
  exit(1);
}

/**************************************************************/
int check_arguments(program)
char program[BUFSIZ];
/* check for reasonable parameters: range, combination etc */
/* Macbeth 19/11/2009 */
/**************************************************************/
{
    int not_error=1;


    if(i_option[1])
    if(!i_option[0])
    if(!Y_option)
    { fprintf(stderr,"%s: Error option Y must be defined with simulated data using allele frequencies with -2 option \n",program);               not_error=0;
    }


    if((!i_option[0])&&(!i_option[1]))
    { fprintf(stderr,"%s: Error  No input data file defined in argument list\n",program);               not_error=0; }
    
    if((!i_option[0])&&(i_option[1]))
    {
      if(!M_option) { fprintf(stderr,"%s: Error option M must be defined when only '-2 FILE' read.\n",program);           not_error=0; }
    }

    if((Y_option)&&(!M_option))
    { fprintf(stderr,"%s: Error option M must be defined with option T\n",program);           not_error=0; }

    if(H_option)
    {
      if(!R_option)
      { fprintf(stderr,"%s: Warning option R not defined (i.e. no recaptures simulated between two populations)\n",program); not_error=1; }

      if(R_value > H_value)
      { fprintf(stderr,"%s: Error option R=%d should be less than H=%d\n",program,R_value,H_value);           not_error=0; }

      if(H_value < H_MIN)
      { fprintf(stderr,"%s: Error option H=%d should be greater or equal to %d\n",program,H_value,H_MIN); not_error=0; }
    }

    if(c_option)
    {
      if(c_value < c_MIN)
      { fprintf(stderr,"%s: Error option c=%d should be greater or equal to %d \n",program,c_value,c_MIN);   not_error=0;}
      if(c_value > c_MAX)
      { fprintf(stderr,"%s: Error option c=%d should be less than or equal to %d \n",program,c_value,c_MAX);   not_error=0;}
    }

    if(b_option)
    if(b_value >= b_MAX)
    { fprintf(stderr,"%s: Error option b=%d (Accepted range is: 0,1 or 2)\n",program,b_value);          not_error=0;}

    if(e_option)
    if((e_value > e_MAX)||(e_value < 1))
    { fprintf(stderr,"%s: Error option e=%6.4f (Accepted range is: 0.0001..%6.4f)\n",program,e_value/10000.0,e_MAX/10000.0);   not_error=0; }

    if(E_option)
    {
      if(M_option)
      {
        if((E_value > E_MAX)||(E_value < 1 ))
        { fprintf(stderr,"%s: Error option E=%6.4f (Accepted range is: 0.0001..%6.4f)\n",program,E_value/10000.0,E_MAX/10000.0);   not_error=0; }
      }
      else
      { fprintf(stderr,"%s: Error option E=%6.4f defined but needs option '-M NUM'\n",program,E_value/10000.0);   not_error=0; }

    }

    if(m_option)
    if(m_value < m_MIN)
    { fprintf(stderr,"%s: Error option m=%d should be greater or equal to %d\n",program,m_value,m_MIN);  not_error=0;}

    if(n_option)
    if((n_value < n_MIN)||(n_value > n_MAX))
    { fprintf(stderr,"%s: Error option n=%d (Accepted range is: %d..%d)\n",program,n_value,n_MIN,n_MAX);  not_error=0;}

    if(M_option)
       if((M_value < M_MIN)||(M_value > M_MAX))
       { fprintf(stderr,"%s: Error option M=%d (Accepted range is: %d..%d)\n",program,M_value,M_MIN,M_MAX);  not_error=0;}

    if(R_option)
    {
      if(M_option)
      {
          if(R_value > (M_value/2))
          { fprintf(stderr,"%s: Error option (R=%d) should be less than or equal to (M/2)=%d/2 \n",program,R_value,M_value);  not_error=0;}
          else if(R_value < R_MIN)
          { fprintf(stderr,"%s: Error option (R=%d) should be greater than 0 and less than or equal to (M/2)=%d/2  \n",program,R_value,M_value);  not_error=0;}
      }
      else
      { fprintf(stderr,"%s: Error M option must be defined with R option\n",program);  not_error=0;}
    }

    if(s_option)
    if((s_value < s_MIN)||(s_value > s_MAX))
    {
      if(s_value) /* zero if set with no arguments for s_DEFAULT to be used */
      {
        fprintf(stderr,"\n%s: Warning option -s=%d (Accepted range is: %d..%d)\n",program,s_value,s_MIN,s_MAX);
        fprintf(stderr,"%s: Default 's' value is: s=%d \n",program,s_DEFAULT);  not_error=0;
      }
      s_value=s_DEFAULT;
    }

    if(Y_option)
      if(M_option&&R_option)
      {
        if((Y_value < Y_MIN)||(Y_value > Y_MAX))
        { fprintf(stderr,"%s: Error option Y=%4.2f (Accepted range is: %4.2f..%4.2f)\n",program,Y_value/100.0,Y_MIN/100.0,Y_MAX/100.0);  not_error=0;}
      }

    if((z_option)&&(z_value > z_MAX))
    { fprintf(stderr,"%s: Error option z=%d (Accepted range is: 1..%d)\n",program,z_value+1,z_MAX);  not_error=0;}
    else if(z_value < 0)
    { 
      if(n_value == 1000) fprintf(stderr,"%s: Error option z=%d (Accepted range is: 0..%d)\n",program,z_value+1,z_MAX);
      else                fprintf(stderr,"%s: Error option z=%d (Accepted range is: 1..%d)\n",program,z_value+1,z_MAX);
      not_error=0;
    }


    if((i_option[0])&&(i_option[1]))
    {
       if(Y_option)
       {
         fprintf(stderr,"\n%s: I assume you are attempting a simulation analysis\n", program);
         fprintf(stderr,"           If so define missing loci combinations:\n");
         fprintf(stderr,"           -   using option \"-T\" OR\n");
         fprintf(stderr,"           -   using bootstrapping using: \"-1 FILE\" but not both methods\n");
         not_error=0;
       }
    }
  
  return(not_error);
}

/**************************************************************/
int check_var()
/* check combinations of args */
/* returns model number */
/* Macbeth 17/12/2009 */
/**************************************************************/
{
  int model=0; /* model not defined  */

  if((M_option)&&(!p_option)) /* simulate        Option */
  {
    if(!i_option[0])                /* #4 */
    {
        model=4;
        if(!Y_option) model=err_msg(model,"Y",1);
        if(b_option) model=err_msg(model,"b",0);
        if(m_option) model=err_msg(model,"m",0);
        if(p_option) model=err_msg(model,"p",0);
    }
    else if(i_option[1])           /* #6 */
    {
        model=6;
        if(b_option) model=err_msg(model,"b",0);
        if(!i_option[0]) model=err_msg(model,"1",1);
        if(Y_option) model=err_msg(model,"Y",0);
        if(p_option) model=err_msg(model,"p",0);

    }
    else if(Y_option)               /* #3 */
    {
        model=3;
        if(!Y_option) model=err_msg(model,"Y",1);
        if(b_option) model=err_msg(model,"b",0);
        if(p_option) model=err_msg(model,"p",0);
        if(m_option) model=err_msg(model,"m",0);
    }
    else                           /* #5 */
    {
        model=5;
        if(b_option) model=err_msg(model,"b",0);
        if(p_option) model=err_msg(model,"p",0);
        if(Y_option) model=err_msg(model,"Y",0);
        if(m_option) model=err_msg(model,"m",0);
    }
  }
  else if(p_option) /* create */
  {
    if(i_option[1])
    {
      if(i_option[0])              /* #10 */
      {
        model=10;
        if(b_option) model=err_msg(model,"b",0);
        if(c_option) model=err_msg(model,"c",0);
        if(e_option) model=err_msg(model,"e",0);
        if(j_option) model=err_msg(model,"j",0);
        if(m_option) model=err_msg(model,"m",0);
        if(n_option) model=err_msg(model,"n",0);
        if(s_option) model=err_msg(model,"s",0);
        if(w_option) model=err_msg(model,"w",0);
        if(z_option) model=err_msg(model,"z",0);
        if(Y_option) model=err_msg(model,"Y",0);
        if(!M_option) model=err_msg(model,"M",1);
      }
      else                         /* #8 */
      {
        model=8;
        if(b_option) model=err_msg(model,"b",0);
        if(c_option) model=err_msg(model,"c",0); 
        if(e_option) model=err_msg(model,"e",0);
        if(j_option) model=err_msg(model,"j",0);
        if(m_option) model=err_msg(model,"m",0);
        if(n_option) model=err_msg(model,"n",0);
        if(s_option) model=err_msg(model,"s",0);
        if(w_option) model=err_msg(model,"w",0);
        if(z_option) model=err_msg(model,"z",0);
        if(!M_option) model=err_msg(model,"M",1);
      }
    }
    else if(Y_option)               /* #7 */
    {
      model=7;
        if(b_option) model=err_msg(model,"b",0);
        if(c_option) model=err_msg(model,"c",0);
        if(e_option) model=err_msg(model,"e",0);
        if(j_option) model=err_msg(model,"j",0);
        if(m_option) model=err_msg(model,"m",0);
        if(n_option) model=err_msg(model,"n",0);
        if(s_option) model=err_msg(model,"s",0);
        if(w_option) model=err_msg(model,"w",0);
        if(z_option) model=err_msg(model,"z",0);
        if(!M_option) model=err_msg(model,"M",1);
    }
    else                           /* #9 */
    {
        model=9;
        if(b_option) model=err_msg(model,"b",0);
        if(c_option) model=err_msg(model,"c",0);
        if(e_option) model=err_msg(model,"e",0);
        if(j_option) model=err_msg(model,"j",0);
        if(m_option) model=err_msg(model,"m",0);
        if(n_option) model=err_msg(model,"n",0);
        if(s_option) model=err_msg(model,"s",0);
        if(w_option) model=err_msg(model,"w",0);
        if(z_option) model=err_msg(model,"z",0);
        if(!M_option) model=err_msg(model,"M",1);
    }
  }
  else /* analyse */
  {
    if(i_option[1])           /* #2 */
    {
        model=2;
        if(E_option) model=err_msg(model,"E",0);
        if(p_option) model=err_msg(model,"p",0);
        if(Y_option) model=err_msg(model,"Y",0);
        if(R_option) model=err_msg(model,"R",0);
        if(M_option) model=err_msg(model,"M",0);

    }
    else if(i_option[0])          /* #1 */
    {
        model=1;
        if(E_option) model=err_msg(model,"E",0);
        if(p_option) model=err_msg(model,"p",0);
        if(Y_option) model=err_msg(model,"Y",0);
        if(R_option) model=err_msg(model,"R",0);
        if(M_option) model=err_msg(model,"M",0);
    }
    else
    {
        fprintf(stdout,"\nNeed to specify a file for reading data.\n");
        fprintf(stdout,"   Please read manual for further information.\n\n");
        model=0; /* error */
    }
  }
  return(model);
}

/**************************************************************/
int err_msg(analysis,option,nono)
int analysis;
char *option;
int nono;
/* Macbeth 19/11/2009 */
/**************************************************************/
{
  if(nono)    fprintf(stdout,"\n\nLooks a bit like Model No: %d but also needs option -%s defined\n",analysis,option);
  else        fprintf(stdout,"\n\nLooks a bit like Model No: %d but with incompatible option -%s\n",analysis,option);
  return(0);
}


/**************************************************************/
int shaza_usage(program)
char program[BUFSIZ];
/* Michael Macbeth 18/11/2009 */
/**************************************************************/
{
   int i;

   fprintf(stdout,"_______________________________________________________");
   for(i=0; i< strlen(program); i++) fprintf(stdout,"_");
   fprintf(stdout,"__________________\n");

   fprintf(stdout,"\nModel     Type      Usage                              ");
   for(i=0; i< strlen(program); i++) fprintf(stdout," ");
   fprintf(stdout,"Permitted options\n");
   
   fprintf(stdout,"_______________________________________________________");
   for(i=0; i< strlen(program); i++) fprintf(stdout,"_");
   fprintf(stdout,"__________________\n");

   fprintf(stdout,"  1       Analyse   %s -1 FILE                           bcdejkmnrswz\n",program);
   fprintf(stdout,"  2       Analyse   %s -1 FILE -2 FILE                   bcdejkmnrswz\n",program);

   fprintf(stdout,"  3       Simulate  %s -1 FILE -M NUM -Y NUM             cdejknrswzEHMRY\n",program);
   fprintf(stdout,"  4       Simulate  %s -2 FILE -M NUM -Y NUM             cdejknrswzEHMRY\n",program);
   fprintf(stdout,"  5       Simulate  %s -1 FILE -M NUM                    cdejknrswzEHMR\n",program);
   fprintf(stdout,"  6       Simulate  %s -1 FILE -2 FILE -M NUM            cdejknrswzEHMR\n",program);

   fprintf(stdout,"  7       Create    %s -1 FILE -M NUM -Y NUM -p          dkprEMHRY\n",program);
   fprintf(stdout,"  8       Create    %s -2 FILE -M NUM -Y NUM -p          dkprEMHRY\n",program);
   fprintf(stdout,"  9       Create    %s -1 FILE -M NUM -p                 dkprEHMR\n",program);
   fprintf(stdout," 10       Create    %s -1 FILE -2 FILE -M NUM -p         dkprEHMR\n",program);
   
   fprintf(stdout,"_______________________________________________________");
   for(i=0; i< strlen(program); i++) fprintf(stdout,"_");
   fprintf(stdout,"__________________\n");

   return(1);
}


/**************************************************************/
/* Written by Michael Macbeth 18/11/2009 */
/* returns 1 if OK else returns 0 */
int get_command_line(program,opt_NUM,opt_STR,opt_NON,argc,argv)
char *program;
char *opt_NUM, *opt_STR, *opt_NON;
char **argv[];
int  *argc;
/**************************************************************/
{
  int rc=1, ai, ci, i;
  int na=0, nf=0;
  char c, **nargv, **files=CNULL;
/*  extern char *strchr();
  extern char *realloc(); */
  char cnum[2];
  int j,len;
  char opt_ALL[BUFSIZ];
  char opt_NUM_STR[BUFSIZ];
  int s_no=0; /* indicator if no argument follows option -s */
  char bb[5];
  int point;


  opt_ALL[0]='\0';
  opt_NUM_STR[0]='\0';
  strcat(opt_NUM_STR,opt_NUM);
  strcat(opt_NUM_STR,opt_STR);

  strcat(opt_ALL,opt_NUM_STR);
  strcat(opt_ALL,opt_NON);


  if((nargv=(char **) malloc(sizeof CSTAR)) == CNULL)
  {
    rc=0;
    fprintf(stderr,"%s: %s\n",*argv[0],"Memory allocation error in get_command_line()");
  }
  else 
  {
    nargv[na++]=(*argv)[0];  /* store program name from 1st arg */
    /* for all args if no rc errors found and not OPTEND found */
    for(ai=1; rc==1 && ai < *argc && strcmp((*argv)[ai],OPTEND); ai++)
    {
      if((*argv)[ai][0] == DASH && (*argv)[ai][1]) /* if DASH followed by a char */
      {
        for(ci=1; rc==1 && ci < (int)strlen((*argv)[ai]); ci++)
        {
          c=(*argv)[ai][ci];
          if(strchr(opt_ALL,c) == CSTAR NULL)
          {
            fprintf(stderr,"\n\n%s: Unrecognised command '%s' \n\n",program,(*argv)[ai]);
            shaza_usage(program);
            exit(1);
          }
          else if ((nargv = (char **) realloc(CSTAR nargv, (na+1)*sizeof CSTAR)) == CNULL)
          {
            rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
            exit(1);
          }
          else if ((nargv[na]=malloc(4*sizeof(char))) == CSTAR NULL)
          {
            rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
            exit(1);
          }
          else
          {
            nargv[na][0]=DASH;
            nargv[na][1]=c;

            if(!strchr(opt_NON,c))  /* if arg followed by string or number */
            if(!strchr("io",c))     /* specical "io" case handled below */
            {
                if(*argc > (ai+1))  /* check if another argument follows */
                {
                  len=strlen((*argv)[ai]);
                  if((*argv)[ai][len-1] == c)
                  {
                    len=strlen((*argv)[ai+1]);
                    if(!strchr(opt_STR,c))  /* if this arg is to followed by number */
                    {
                       point=0; /* ount decimal point */
                       if((c == 's')&&(!isdigit((*argv)[ai+1][0])))  s_no=1;
                       else
                       for(j=0; j<len; j++)
                       if(!isdigit( (*argv)[ai+1][j] ))
                       {
                         if( ((c == 'e')||(c == 'E')||(c == 'T')||(c == 'Y'))&&( (*argv)[ai+1][j] == '.') )
                         {
                           if(point)
                           {
                             rc=0;
                             fprintf(stderr,"\n%s: Argument following option '-%c' has more than one '.' \n",program,c);
                           }
                           
                           point++;
                         } /* allow deimal point */
                         else
                         {
                           rc=0;
                           fprintf(stderr,"\n%s: Option '-%c' not followed by a space before digits. Offending character was '%c'\n",program,c,(*argv)[ai+1][j]);
                           j=len;
                         }
                       }
                    }
                    else /* option followed by string */
                    {
                       if( '-' == (*argv)[ai+1][0] )
                       {
                         rc=0;
                         fprintf(stderr,"\n%s: String following option '-%c' should not begin with '-' \n",program,c);
                       }
                    }
                  }
                  else /* not last option in string */
                  {
                    rc=0;
                    fprintf(stderr,"\n%s: Option '-%c' not followed by space before option argument\n",program,c);
                  }
                }
                else /* no argument follows */
                {
                  if(c == 's') s_no=1;
                  else
                  {
                    rc=0;
                    fprintf(stderr,"\n%s: Option '-%c' not followed by space before option argument\n",program,c);
                  }
                }
            }

            if('o' == c)  /* "o1..MAX_o STR" special case */
                          /* required to read non-default names of output files */
            {
              nargv[na][2]=(*argv)[ai][++ci];
              cnum[0]=nargv[na][2];
              cnum[1]='\0';
              if(*argc > (ai+1))
              {
                if( (!isdigit(cnum[0])) || (atoi(cnum) > MAX_o) )
                {
                  rc=0;
                  fprintf(stderr,"\n%s: Option '-%c' not followed by a digit o[1..%d] a space then <filename>\n",program,c,MAX_o);
                }
                else
                if( (*argv)[ai][3] != '\0' )
                {
                  rc=0;
                  fprintf(stderr,"\n%s: Option '-%c%c' not followed by a space then <filename>\n",program,c,cnum[0]);
                }
                else /* option followed by string */
                {
                  if( '-' == (*argv)[ai+1][0] )
                  {
                    rc=0;
                    fprintf(stderr,"\n%s: Filename following option '-%c%c' should not begin with '-' to assist checking program arguments\n",program,c,cnum[0]);
                  }
                }
                nargv[na++][3]='\0';
              }
              else
              {
                rc=0;
                if( (!isdigit(cnum[0])) || (atoi(cnum) > MAX_o) )
                  fprintf(stderr,"\n%s: Option '-%c' not followed by a digit o[1..%d] a space then <filename>\n",program,c,MAX_o);
                else
                  fprintf(stderr,"\n%s: Option '-%c%c' not followed by a space then <filename> \n",program,c,cnum[0]);
              }
            }
            else nargv[na++][2]='\0';

            /* store options with arguments in nargv */
            if(strchr(opt_NON,c)) { /* options with no argument do nothing */}
            else if ((nargv = (char **) realloc(CSTAR nargv, (na+1)*sizeof CSTAR)) == CNULL) /* allocate more memory for nargv */
              rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
            else if (ai+1 < *argc)  /* if there are more arguments in command string */
            {
              if((s_no)&&(c == 's' ))
              {
                sprintf(bb,"%d",s_DEFAULT);
                nargv[na++]=bb;   /* add iDEFAULT argument for this option if no argument in command line */
                ci=strlen((*argv)[ai]);

              }
              else
              {
                nargv[na++]=(*argv)[++ai];   /* add argument for this option */
                ci=strlen((*argv)[ai]);  /* terminate ci loop */
              }

#ifdef SECOND_DIGIT  // TODO: will not work in other code yet
              /* read second digit if any for option M E or Y */
              if((c == 'M')||(c == 'E')||(c == 'Y'))
              if( (*argv)[ai+1] != NULL )                /* if not end of arg list */
              if( check_int2((int)((*argv)[ai+1])) > -1) /* if next arg is an integer */
              {
                ci=strlen((*argv)[ai]); 
                if ((nargv = (char **) realloc(CSTAR nargv, (na+1)*sizeof CSTAR)) == CNULL) /* allocate more memory for nargv */
                  rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
                nargv[na++]=(*argv)[++ai];
              }
#endif


            }
            else if((s_no)&&(c == 's' ))  /* no more arguments but can add default */
            {
              sprintf(bb,"%d",s_DEFAULT);
              nargv[na++]=bb;   /* add iDEFAULT argument for this option if no argument in command line */
            }
          }

        }

      }
      else  /* nf error: options found without DASH prefix OR no char after DASH */
      if(nf == 0)
      {
        if((files = (char **)malloc(sizeof CSTAR)) == CNULL)
          rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
        else  files[nf++]=(*argv)[ai];
      }
      else if((files = (char **)realloc(CSTAR files,(nf+1)*sizeof CSTAR)) == CNULL)
        rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
      else files[nf++]=(*argv)[ai];

    }

    if(rc)  /* if no rc errors */
    {
      if(ai < *argc && !strcmp((*argv)[ai],OPTEND)) ai++;

      if((nargv = (char **)realloc(CSTAR nargv,(na+nf+(*argc-ai)+2)*sizeof CSTAR)) == CNULL)
        rc=error(program,"Memmory allocation error in get_command_line()",' ',"");
      else
      {
        nargv[na++]=OPTEND;
        for(i=0; i  < nf;  i++)
        {
          nargv[na++] = files[i];
          rc=0;
          fprintf(stderr,"\n\nUnknown option parameter: \"%s\"\n\n",files[i]);
        }

        nargv[na]=CSTAR NULL;
      }
    }
    if(files) free(CSTAR files);
  }

  if(rc == 1)
  {
    *argv=nargv;
    *argc=na;
  }
  else if(nargv != CNULL) free(CSTAR nargv);

  return(rc);
}


/**************************************************************/
int error(s0,s1,c1,s2)
char s0[BUFSIZ];
char s1[BUFSIZ];
char c1;
char s2[BUFSIZ];
/**************************************************************/
{

   fprintf(stderr,"\n%s: %s-%c%s\n\n",s0,s1,c1,s2);

   return(0);
}

/*************************************************************************************/
int check_int2(a)
/* coded by: Michael Macbeth       revision - 27/7/2010     */
/* no decimal places allowed */
/* no negative nor positive sign allowed */
/* returns -1 if not positive integer */
/*************************************************************************************/
char *a;
{
   int i;

   for( i = 0 ; i < (int)strlen(a) ; i++)
   {
      if( ((a[i] >= '0') && (a[i] <= '9')) || a[i] == '\0' ) { }
      else
      {
        return(-1);
      }
   }
   return((int)atof(a)); 
}

