#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>


#define DASH        '-'
#define OPTEND      "--"
#define CNULL       (char **)NULL

#define CSTAR       (char *)

#define MAX_i       2   /* Number of input files  */
#define MAX_o       9   /* Number of output files */

#define STR2        400 /* string length in input data */
                        /* should be the same as STR in shaza.h */

/* String list of option arguments */
#define ARG_NUM   "HbceEmnMrRsTYz"           /* arguments with an int parameter */
#define ARG_STR   "12dk"                     /* arguments with an string parameter */
#define ARG_NON   "fjpw"                     /* arguments with no following parameter */



/*                                                                      default_name defined in command.h      */                                 
/* output file pointers                                                 /////////////////////////////////      */
FILE *fp0;         /* allele loci      data file                        SHAZA_loci.txt                         */
FILE *fp1;         /* allele frequency data file                        SHAZA_freq.dat                         */
FILE *fp2;         /* missing allele report                             SHAZA_miss.txt                         */
FILE *fp3;         /* statistics        report                          SHAZA_stat.txt                         */
FILE *fp5;         /* report on animals that have pairwise matches      SHAZA_pair.txt                         */
FILE *fp6;         /* population summary report                         SHAZA_pop.txt                          */
FILE *fp7;         /* stdout log                                        SHAZA_log.txt                          */
FILE *fp8;         /* test                                                                                     */
FILE *fp_sp;       /* simulated data with missing genotypes             SHAZA_simm.dat                         */
FILE *fp_in;       /* base pair data file                               (user defined)                         */

/* default arg settings for output file names */
#define o_FILE_0    "_freq.txt"        /* report of allele frequencies from ?reference_file? */
#define o_FILE_1    "_miss.txt"        /* report of missing loci combinations */
#define o_FILE_2    "_pair.txt"        /* report of pairwise matches with shadow estimation */
#define o_FILE_3    "_pop.txt"         /* match report from different population cohorts at given shadow rate */
#define o_FILE_4    "_stat.txt"        /* statistics on phantoms and matches at different shadow rates */
#define o_FILE_5    "_simm.txt"        /* simmulated data file generated as 'reference file' for recapture estimation */
#define o_FILE_6    "_join.txt"        /* genotype file created from composite joins of match pairs */
#define o_FILE_7    "_loci.txt"        /* short '-2 FILE' format of allele frequencies generated from '-1 FILE' */
#define o_FILE_8    "_log.txt"         /* stdout log */
#define TEMP_FILE   "SHAZA_temp.txt"   /* temporary file used */


/* other default arg settings */
/* the first letter corresponds to option in SHAZA manual */
#define  b_DEFAULT   1
#define  c_DEFAULT   10
#define  d_DEFAULT "SHAZA"
#define  e_DEFAULT 100
#define  k_DEFAULT "POP"
#define  k_DEFAULT1 "Pop"
#define  k_DEFAULT2 "pop"
#define  m_DEFAULT  10
#define  n_DEFAULT 200
#define  r_DEFAULT   0
#define  s_DEFAULT 100
#define  z_DEFAULT   5
#define  H_DEFAULT   0
#define  M_DEFAULT   0
#define  R_DEFAULT   0
#define  Y_DEFAULT 100

/* maximum and minimum argument settings */
#define b_MAX 3
#define e_MAX 2000
#define c_MIN 0
#define c_MAX 10
#define E_MAX 2000
#define n_MIN 100 
#define n_MAX 1000       /* n_MAX should not exceed LOOP_SFZ defined in shaza.h */
#define H_MIN 20
#define M_MIN 50
#define M_MAX 30000    /* WARNING: Make sure M_MAX is equal to ANIM in shaza.h */
#define m_MIN 3
#define R_MIN 0
#define s_MIN 10 
#define s_MAX 10000
#define Y_MIN 50
#define Y_MAX 100
#define z_MAX 50



int scf();
int shaza_usage();
int error();
void program_name();

/*  Global argument definitions         */
/****************************************/
/* ARG_NUM list */
extern int b_option;       extern int b_value;
extern int c_option;       extern int c_value;
extern int e_option;       extern int e_value;
extern int m_option;       extern int m_value;
extern int n_option;       extern int n_value;
extern int r_option;       extern int r_value;
extern int s_option;       extern int s_value;
extern int z_option;       extern int z_value;
extern int E_option;       extern int E_value;
extern int H_option;       extern int H_value;
extern int M_option;       extern int M_value;
extern int R_option;       extern int R_value;
extern int Y_option;       extern int Y_value;


/* ARG_STR list */
                                                    
extern int i_option[MAX_i];  extern char *i_value[MAX_i];
extern int k_option;         extern char *k_value;
extern int o_option[MAX_o];  extern char *o_value[MAX_o];
extern int d_option;         extern char *d_value;

/* ARG_NON list */
extern int j_option;
extern int f_option;
extern int H_option;
extern int p_option;
extern int w_option;

extern char o_default[MAX_o][BUFSIZ];
extern char Xd_value[BUFSIZ];
extern char Xk_value[102];

void                rand_seed();          /* initialise seed for random number generation              */
void                open_files();         /* open input and output files to run this program           */
void                close_files();        /* close input and output files to run this program          */
int                 get_command_line();   /* reads args */
int                 check_var();
