#include "shaza.h"
#include "command.h"
/*************************************************************************************/
/* form composite genotypes from matching pairs */
void composite(nloci, ngroup, nlist,anim,fptr)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int nloci;     /* number of loci */
int ngroup;    /* number of groups with no matches between them */
int nlist;     /* number of unique samples across all pair-wise matches */
int anim;      /* number of genotype samples */
FILE *fptr;
{
  int i,j,k;
  int ai,aj,copy;    /* animal numbers  */
  int gp;    /* group number  */
  int ***animal_comp; /* 3 dimensional array */
  unsigned int space; /* holds memory location of int list */

  /* create 3D int array */
  animal_comp=create3Dint(ngroup,nloci,2,&space);

  /* initialise */
  for(gp=0; gp<ngroup; gp++)
  for(k=0; k<nloci; k++)
  for(i=0; i<2; i++)
  animal_comp[gp][k][i] = 0;

  for(i=0; i<nlist; i++) /* for every record in animal list (unique list from all pairs) */
  for(j=0; j<nlist; j++) /* todo efficiency ? */
  if(i != j)
  {
    if(one_list[i][1] == one_list[j][1])  /* if in same group */
    {
      gp=one_list[i][1]-1;
      ai=one_list[i][0];
      aj=one_list[j][0];

      for(k=0; k<nloci; k++)
      {
        if(animal_comp[gp][k][0] == 0)  /* this will need to be changed if code based on individual alleles */
        {                              /* assumes if 1st allele missing then second is also missing */
          copy=-1;
          if(animal_data[ai][k][0] != 0)
          {
            if(animal_data[aj][k][0] != 0)
            {
              if(animal_data[aj][k][0] != animal_data[aj][k][1])
              {
                copy = aj;  /* prefer heterozygote */
              }
              else copy = ai;  /* could be hetero or homo */
            }
          }
          else if(animal_data[aj][k][0] != 0)  copy = aj;

          if(copy >= 0)
          {
              animal_comp[gp][k][0]=animal_data[copy][k][0];
              animal_comp[gp][k][1]=animal_data[copy][k][1];
          }

        }
        else /* find and replace alleleic dropout */
        if(animal_comp[gp][k][0] == animal_comp[gp][k][1]) /* if homo */
        {
           if(animal_data[ai][k][0] != animal_data[ai][k][1])
           {
              animal_comp[gp][k][0]=animal_data[ai][k][0];
              animal_comp[gp][k][1]=animal_data[ai][k][1];
           }
           else
           if(animal_data[aj][k][0] != animal_data[aj][k][1])
           {
              animal_comp[gp][k][0]=animal_data[aj][k][0];
              animal_comp[gp][k][1]=animal_data[aj][k][1];
           }
        }
      }
    }
  }

  /* write composite genotypes to file */
  write_composites(nloci,anim,nlist,ngroup,animal_comp,fptr);

  /* free memory */
  free3Dint(animal_comp,ngroup,space);

}


