#include "command.h"

/*************************************************************************************/
int ***create3Dint(X_DIM,Y_DIM,Z_DIM,spaceint)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int X_DIM;
int Y_DIM;
int Z_DIM;
unsigned int *spaceint;  /* this address is passed for freeing memory using free3Dint() */
{   
    int *space;
    int ***Arr3D; 
    int x,y;

    /* first we set aside space for the contiguous array of ints */
    space = malloc(X_DIM * Y_DIM * Z_DIM * sizeof(int));
    if(space == NULL) 
    { 
      fprintf(fp7,"Malloc errror 1 in create3Dint()\n");
      fprintf(stdout,"Malloc errror 1 in create3Dint()\n");
      exit(1); 
    }

    /* next we allocate space of an array of pointers, each
       to eventually point to the first element of a
       2 dimensional array of pointers to pointers */
    Arr3D = malloc(X_DIM * sizeof(int **));
    if(Arr3D == NULL) 
    { 
      fprintf(fp7,"Malloc errror 2 in create3Dint()\n");
      fprintf(stdout,"Malloc errror 2 in create3Dint()\n");
      exit(1); 
    }

    /* and for each of these we assign a pointer to a newly
       allocated array of pointers to a row */
    for (x = 0; x < X_DIM; x++)
    {
        Arr3D[x] = malloc(Y_DIM * sizeof(int *));
        if(Arr3D[x] == NULL)
        {
          fprintf(fp7,"Malloc errror 3 in create3Dint()\n");
          fprintf(stdout,"Malloc errror 3 in create3Dint()\n");
          exit(1);
        }

        /* and for each space in this array we put a pointer to
           the first element of each row in the array space
           originally allocated */

        for (y = 0; y < Y_DIM; y++)
        {
            Arr3D[x][y] = space + (x*(Z_DIM * Y_DIM) + y*Z_DIM);
        }
    }

    *spaceint=(unsigned int)space; 

    return(Arr3D);
}


/*************************************************************************************/
void free3Dint(Arr3D,X_DIM,space_ptr)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int ***Arr3D;
int X_DIM;
unsigned int *space_ptr;
{
  int x;

  for (x = 0; x < X_DIM; x++)
  if(Arr3D[x]  != NULL) free(Arr3D[x]);

  if(Arr3D     != NULL) free(Arr3D);
  if(space_ptr != NULL) free(space_ptr);
}

