#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void get_LZones(model,nloci,anim)   /* finds false positive cut-off zones on likelihood */
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int model;
int nloci;  /* number of loci */
int anim;   /* number of samples in data */
{
   int i,j,k,irun;
   unsigned int bit;
   unsigned int rec_mbit_L[ANIM];
   int iperm;

   /* Backup missing loci combinations read or created */
   for(i=0; i< anim; i++) rec_mbit_L[i]=rec[i].mbit;

   for(irun=0; irun <n_value; irun++)  /* Likelihood Shadow Simulation Runs*/
   {
      fprintf(stdout,".");
      fflush(stdout);

      /* define missing loci combinations */
      bitperm(0,0,1,' ');
      if(i_option[0])
      {
         /* randomly bootstrap missing loci combinations from reference data (across all data) */
         /* The LLR distribution should also be similar to simulating combinations within temporal/spatial groups */
         get_mbit3(anim,&iperm,anim,rec_mbit_L);
      }
      else
      {
         /* simulate loci combinations from proportion typed */
         get_mbit(anim,nloci,&iperm,Y_value);
      }

      sim_genotypes(model,nloci,anim,0,1);
                                    /* 0,    no recaps                                       */
                                    /*  ,1   isim: store simulated genotypes in animal_sim[] */

      toplikelihood_inds(0,0,0,0,0);   /* initialise toplike[k][i] array which stores top likelihoods by defining is=0 */

      for(i=0; i < anim; i++)           /* lower triangular animal matrix   (vertical)   */
      for(j=0; j < i;    j++)           /* lower triangular animal matrix  (horizontal)  */
      {
         bit=(rec[i].mbit&rec[j].mbit);
         if(bit) toplikelihood_inds(i,j,nloci,bit,RANK_SFZ); /* finds largest LLR and fills in toplikes[] */
      }

      for(k=0; k<RANK_SFZ; k++) toplike[irun][k]=toplikes[k];
   }

   /* find LLR cutoff based on top LLRs recorded in toplike[][] */
   i=0;
   for(k=0; k <RANK_SFZ; k++)
   for(irun=0; irun <n_value; irun++)
   tot[i++]=toplike[irun][k];
   qsort(tot,RANK_SFZ*n_value,sizeof(double),compare_double);

   /* LLR curoff for given number of false positives */
   for(k=0; k <RANK_SFZ; k++)
   LLRcut[k]=tot[(int)(alphaCut[k]*n_value)];

   /* restore mbit in original real_data file */
   for(i=0; i< anim; i++) rec[i].mbit=rec_mbit_L[i];
}

