#include <math.h>
#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void get_corrected_match(j,iaa,ibb,rlist,alpha,E1,E2,E12,N1,N2,N12,corR1,corR2,corR12,pctR1,pctR2,pctR12,PIR1,PIR2,PIR12)
/* coded by: Michael Macbeth       revision - 6/10/2009     */
int    j;
int    iaa;                    /* block number 1 */
int    ibb;                    /* block number 2 */
int    *rlist;                 /* list of recaptures */
double alpha;                  /* number of false positives */
double E1,E2,E12;              /* effective sample size in group 1, 2 and (1 by 2 )*/
int    N1,N2;                  /* effective block size in group 1 and 2 */
double N12;                    /* effective block size in group 1 by 2 */
double *corR1,*corR2,*corR12;  /* corrected recapture */
double *pctR1,*pctR2,*pctR12;  /* percentage recapture */
double *PIR1,*PIR2,*PIR12;     /* probability of individual resample */
/*************************************************************************************/
{

   /* stochastic simulation may lead to some variables to cause log problems */
   /* adjustments below help make this program more robust */
   if(E12 > N12) E12=N12;
   if(E12 < rlist[j]) E12=rlist[j];



   *PIR12=1.0-exp(log(1.0-(rlist[j]-alpha)/E12)/E12);
   if((*PIR12) < 0)
   {
     *corR12=0.0;
     *pctR12=0.0;
   }
   else
   {
     *corR12=N12*(1.0-pow((1.0-(*PIR12)),N12));
     *pctR12=100.0*(*corR12)/(N12-(*corR12));
   }


   if(iaa != ibb)
   {
     /* stochastic simulation may lead to some variables to cause log problems */
     /* adjustments below help make this program more robust */
     if(E1 > N1) E1=N1;
     if(E1 < rlist[j]) E1=rlist[j];
     if(E2 > N2) E2=N2;
     if(E2 < rlist[j]) E2=rlist[j];

     /* individual match */
     *PIR1=1.0-exp(log(1-(rlist[j]-alpha)/E1)/E1);
     if((*PIR1) < 0.0)
     {
       *corR1=0.0;
       *pctR1=0.0;
     }
     else
     {
       *corR1=N1*(1.0-pow((1.0-(*PIR1)),N1));
       *pctR1=100.0*(*corR1)/N1;
     }

     *PIR2=1.0-exp(log(1-(rlist[j]-alpha)/E2)/E2);
     if((*PIR2) < 0.0)
     {
       *corR2=0.0;
       *pctR2=0.0;
     }
     else
     {
       *corR2=N2*(1.0-pow((1.0-(*PIR2)),N2));
       *pctR2=100.0*(*corR2)/N2;
     }

   }
}


