#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void get_loci_combinations(nloci,model,iperm0,num_block0,anim0)
int nloci;
int model;
int *iperm0;
int *num_block0;
int *anim0;
/* coded by: Michael Macbeth       revision - 2/12/2013    */
/*************************************************************************************/
{
   int i;
   int anim=0;
   int nlociB, anim_L, num_block;
   int iperm=1;
   unsigned int        rec_mbit_L[ANIM];               /* store loci missing value combinations for bootstrapping */

    /* get missing loci combinations from data or by simulation */
    if(!(model == 2))   /* model 2 has real data so do not simulate */
    {
      anim=M_value+H_value;
      if(H_value) num_block=2;
      else        num_block=1;

      nBlock[0]=0;
      nBlock[1]=M_value;
      nBlock[2]=anim;
    }

    if((i_option[0])&&(i_option[1])) /* if both files -1 FILE and -2 FILE read: models 2,6 and 10 */
    {
       /* read alleles from -1 FILE to read loci combinations for bootstrapping */
       if(model == 2)
       {
         fprintf(fp7,"          Reading alleles for match analysis from:                      FILE: \"%s\" \n",i_value[0]);
         fprintf(stdout,"          Reading alleles for match analysis from:                      FILE: \"%s\" \n",i_value[0]);

       }
       else
       {
         fprintf(fp7,"          Reading alleles for bootstrapping loci combinations:          FILE: \"%s\" \n",i_value[0]); fflush(stdout);
         fprintf(stdout,"          Reading alleles for bootstrapping loci combinations:          FILE: \"%s\" \n",i_value[0]); fflush(stdout);
       }
       if(!f_option)  /* GENEPOP data */
       {
         fprintf(fp7,"          GENEPOP input format assumed with '-f' flag on command line.\n");
         fprintf(stdout,"          GENEPOP input format assumed with '-f' flag on command line.\n");
         read_base_pairs_GENEPOP(&nlociB,&anim_L,&num_block,ANIM);
       }
       else
       {
         fprintf(fp7,"          SHAZA input format assumed.\n");
         fprintf(stdout,"          SHAZA input format assumed.\n");
         read_base_pairs(&nlociB,&anim_L,&num_block,ANIM);
       }
       if(nloci != nlociB)
       {
         fprintf(fp7,"There are %d number of loci read from FILE: \"%s\"  \n",nloci,i_value[1]);
         fprintf(fp7,"This differs from %d number of loci read from FILE: \"%s\"  \n",nlociB,i_value[0]);
         fprintf(fp7,"Please address this difference before running SHAZA again.\n"); fflush(stderr);
         fprintf(stdout,"There are %d number of loci read from FILE: \"%s\"  \n",nloci,i_value[1]);
         fprintf(stdout,"This differs from %d number of loci read from FILE: \"%s\"  \n",nlociB,i_value[0]);
         fprintf(stdout,"Please address this difference before running SHAZA again.\n"); fflush(stderr);
         exit(1);
       }
       fprintf(fp7,"          A total of %d genotype samples were read from %d loci.\n\n",anim_L,nloci);
       fprintf(stdout,"          A total of %d genotype samples were read from %d loci.\n\n",anim_L,nloci);

       if(model == 2)  /* use genotypes and mbit combinations from read_base_pairs() stored in animal_data[][][] */
       {
         anim=anim_L;
         get_mbit2(anim,&iperm);
       }
       else    /* redefine mbit using bootstrapping (models 6 and 10) */
       {
         nBlock[0]=0;    /* nBlock[] changed in read_base_pairs (above)... so need to change back for simulation */
         nBlock[1]=M_value;
         nBlock[2]=anim;

         /* Store missing loci combinations */
         for(i=0; i< anim_L; i++) rec_mbit_L[i]=rec[i].mbit;

         /* randomly define missing loci combinations for each animal */
         get_mbit3(anim,&iperm,anim_L,rec_mbit_L);  /* randomly BOOTSTRAP missing loci combinations for each genotype sample */
       }
    }
    else  /* (model 4 and 8) with -2 FILE only */
    {
       /* define missing loci combinations using -T NUM */
       bitperm(0,0,1,' ');  /* initialise rec[].mbit */
       get_mbit(anim,nloci,&iperm,Y_value); /* randomly define missing loci combinations for each animal in rec[].mbit        */

    }
    *iperm0=iperm;
    *num_block0=num_block;
    *anim0=anim;
}

