#include "shaza.h"

/*************************************************************************************/
void get_mbit(anim,nloci,nperm,pct_typed)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* set missing loci values                                                           */
/*************************************************************************************/
int anim;       /* animals */
int nloci;      /* number of loci */
int *nperm;     /* number of missing loci combinations */
int pct_typed;  /* percentage of loci typed */
{
   int i,locus;
   int iperm=0;
   unsigned int bit1,bit2,bit3;
   double ptyped;  /* proportion of loci typed */

   ptyped=(double)pct_typed/100.0;
   bit1=~0;
   bit2=0;
   for(i=nloci; i < 32; i++)
   bit2=bit2|(1<<(i));     /* loci bits not used */
   bit3=bit1^bit2;         /* only loci bits used have bit=1 */

   for(i=0; i < anim; i++)
   {
      rec[i].mbit=bit3;   /* set all loci bits to ones (unused are zero) */

      /* set missing value for each locus */
      for(locus=0; locus < nloci; locus++)
      {
            if( drand() >  ptyped) rec[i].mbit^=(1<<locus);        
      }
      /* do not generate samples with all missing data */
      if(!rec[i].mbit) i--;  /* do another run for this animal */
      else iperm=bitperm(rec[i].mbit,1,0,'s');
   }

   *nperm=iperm;
}




