#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void get_recaps_from_data(model,nloci,anim,nblocks,totalPairs,ci)
/* coded by: Michael Macbeth       revision - 28/06/2011     */
/*************************************************************************************/
int model;
int nloci;          /* number of loci */
int anim;           /* number of genotype samples in data */
int nblocks;        /* number of time/space/treatment groups in data */
int *totalPairs;    /* number of putative pairs including those with false positives > alphaCut[z_value] */
int ci;            /* convergence iteration */
{
   int i,k;
   int pairs;
   int totalPairs2;
   double effectiveSampleSize;
   int z001;

   find_like_recap_data(model,nloci,anim,nblocks,0,0,&totalPairs2,&effectiveSampleSize);

   /* count of match pairs within alphaCut[z_value] match criteria */
   if(totalPairs2 > 1) qsort(mat_pairs[0],totalPairs2,sizeof(struct matches),compare_LLR);
   pairs=0;

   for(i=0; i<totalPairs2; i++)
   if( LLR2alpha(mat_pairs[0][i].LLR) < alphaCut[z_value] ) pairs++;

   for(k=0; k<RANK_SFZ; k++) d_pairs[k]=0;

   for(i=0; i<totalPairs2; i++)
   for(k=0; k<RANK_SFZ; k++)
   if( LLR2alpha(mat_pairs[0][i].LLR) < alphaCut[k] ) d_pairs[k]++;


   if(!ci)
   {
   /* print report for all k alpha values in SHAZA_summ.txt */
   fprintf(fp3,"\n\n\n\n\n\n______________________________________________________________________________________________\n\n");
   fprintf(fp3,"Table 1  Cumulative matches in reference data when increasing false positives (-z NUM)\n");
   fprintf(fp3,"         Determined from pooled data over all POP=%d populations\n",nblocks);
   
   fprintf(fp3,"\n\n  z   LLR          False     Matches  Recaps.  False      Effective   Corrected   Percentage\n");
       fprintf(fp3,"      threshold    positives                   negatives  size        recaptures  recaptures\n");
       fprintf(fp3,"      (LLRv)       (V)       (M)       (M-V)   (T)        (E)         (M-V+T)               \n");
   fprintf(fp3,"______________________________________________________________________________________________\n");

   if(n_value == 1000) z001=0;   else z001=1;  /* set to = 0 if smallest z false positive = 0.001 */
                                               /* this is to keep -z 6 = 0.75 false positives     */
   for(k=0; k< RANK_SFZ; k++)
   {
     fprintf(fp3,"%3d %9.2f ",k+z001,LLRcut[k]);
     if(alphaCut[k] < 0.15) fprintf(fp3,"  %9.3f   ",alphaCut[k]);
     else                   fprintf(fp3," %9.2f    ",alphaCut[k]);
     fprintf(fp3,"%5.0f  %9.2f  %9.2f  %9.2f   %9.2f  %9.2f\n",d_ngood[k],d_R[k],d_Rcor[k]-d_R[k],d_Ex[k],d_Rcor[k],d_pctR[k]);
   }
   fprintf(fp3,"\n\n"); fflush(fp3);
   }

   *totalPairs=totalPairs2;
}


