#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void  get_reference_data(model,nloci,anim,num_block,nstage)
/* generates reference data */
/* coded by: Michael Macbeth       revision - 7/2/2010    */
/*************************************************************************************/
int model;
int nloci;
int anim;
int num_block;
int nstage;
{


  if((model == 3)||(model == 7))
  {

        /* define missing loci combinations using -T */
        fprintf(fp7,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);
        fprintf(stdout,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);    fflush(stdout);
        if(num_block > 1)
        {
          fprintf(fp7,"          This reference data has %d samples containing %d recaptures in %d populations.\n",anim,R_value,num_block);
          fprintf(stdout,"          This reference data has %d samples containing %d recaptures in %d populations.\n",anim,R_value,num_block);
        }
        else
        {
          fprintf(fp7,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);
          fprintf(stdout,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);    fflush(stdout);
        }
        fprintf(fp7,"          Missing loci combinations randomly sampled using Y=%4.2f\n",Y_value/100.0);    fflush(stdout);
        fprintf(stdout,"          Missing loci combinations randomly sampled using Y=%4.2f\n",Y_value/100.0);    fflush(stdout);
  }
  else
  if((model == 5)||(model == 9))
  {
    fprintf(fp7,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);
    fprintf(stdout,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);    fflush(stdout);
    if(num_block > 1)
    {
      fprintf(fp7,"          This reference data has %d samples containing %d recaptures in %d population(s).\n",anim,R_value,num_block);
      fprintf(stdout,"          This reference data has %d samples containing %d recaptures in %d population(s).\n",anim,R_value,num_block);
    }
    else
    {
      fprintf(fp7,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);    fflush(stdout);
      fprintf(stdout,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);    fflush(stdout);
    }
    fprintf(fp7,"          Missing loci combinations defined from:\n");
    fprintf(fp7,"                  random sampling of missing alleles. \n\n");
    fprintf(stdout,"          Missing loci combinations defined from:\n");
    fprintf(stdout,"                  random sampling of mising alleles. \n\n");    fflush(stdout);
  }
  else
  if((model == 4)||(model == 6)||(model == 8)||(model == 10))
  {
    fprintf(fp7,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);    fflush(stdout);
    fprintf(stdout,"STAGE %2d: Writing simulated reference genotypes to:                     FILE: \"%s\"\n",nstage,o_value[5]);    fflush(stdout);

    if(num_block > 1)
    {
      fprintf(fp7,"          This reference data has %d samples containing %d recaptures in %d population(s).\n",anim,R_value,num_block);
      fprintf(stdout,"          This reference data has %d samples containing %d recaptures in %d population(s).\n",anim,R_value,num_block);
    }
    else
    {
      fprintf(fp7,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);    fflush(stdout);
      fprintf(stdout,"          This reference data has %d samples containing %d recaptures.\n",anim,R_value);    fflush(stdout);
    }

    if((model == 4)||(model == 8))
    {
      fprintf(fp7,"          Missing loci combinations randomly sampled using Y=%4.2f\n",Y_value/100.0);    /* see get_loci_combinations */
      fprintf(stdout,"          Missing loci combinations randomly sampled using Y=%4.2f\n",Y_value/100.0);    /* see get_loci_combinations */
    }
    else  /* models 6 10 */  
    {
      fprintf(fp7,"          Missing loci combinations defined \n");
      fprintf(stdout,"          Missing loci combinations defined \n");
      fprintf(fp7,"                  by random sampling of missing alleles. \n\n");    fflush(stdout);
      fprintf(stdout,"                  by random sampling of missing alleles. \n\n");    fflush(stdout);
    }
  }

  sim_genotypes(model,nloci,anim,R_value,0); /* 0 store in: animal_data[][][] */

  /* GENEPOP format from animal_data[][][] */
  print_genotype_data_GENEPOP(nloci,anim,o_value[5],0,0,fp_sp);
  /* SHAZA format */
  /*print_genotype_data(nloci,anim,o_value[5],0,0,fp_sp);   */
}


