#include <math.h>
#include "shaza.h"
#include "command.h"
/*************************************************************************************/
double like_ind(f21,f22,k11,k12,k21,k22,m)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* log likelihood of match between two samples */
/*************************************************************************************/
/*double f11,f12;   frequency of allele 1 and 2 in 1st sample */
double f21,f22;  /* frequency of allele 1 and 2 in 2nd sample */
int k11,k12;     /* allele number 1 and 2       in 1st sample */
int k21,k22;     /* allele number 1 and 2       in 2nd sample */
int *m;          /* = 0 if new sample being compared          */
{
  static double like; /* match likelihood */
  double e=e_value/10000.0;
  double g2;      /* locus genotype probability */
  /* double g1,H1,H2;      H1=Hypothesis H2=Alternative Hypothesis   */
  /*double tp;          transitional probability for match */
  static double ea,eb;

  if(k21 == k22) g2=f21*f22;  else g2=2.0*f21*f22;

  if(*m == 0)  /* if first likelihood */
  {
    *m=1;
    ea=(1-e)*(1-e);
    eb=e*(2-e);

    /* if loci match with both alleles */
    if( ( (k11 == k21)&&(k12 == k22) )||( (k11 == k22)&&(k12 == k21) ))
    {  /* tp=transitional probability */
       /*tp=1.0;
       H1=(1-e)*(1-e)*tp*g1+2*e*(1-e)*g1*g2+e*e*g1*g2;
       H2=(1-e)*(1-e)*g1*g2+2*e*(1-e)*g1*g2+e*e*g1*g2;
       like=H1/H2; */
       like=ea/g2+eb;
    }
    else
    {  /* tp=transitional probability */
       /*tp=0.0;
       H1=(1-e)*(1-e)*tp*g1+2*e*(1-e)*g1*g2+e*e*g1*g2;
       H2=(1-e)*(1-e)*g1*g2+2*e*(1-e)*g1*g2+e*e*g1*g2;
       like=H1/H2; */
       like=eb;
    }
  }
  else
  {
    if( ( (k11 == k21)&&(k12 == k22) )||( (k11 == k22)&&(k12 == k21) ))
    {  /* tp transitional probability */
       /*tp=1.0;
       H1=(1-e)*(1-e)*tp*g1+2*e*(1-e)*g1*g2+e*e*g1*g2;
       H2=(1-e)*(1-e)*g1*g2+2*e*(1-e)*g1*g2+e*e*g1*g2;
       like=like*H1/H2; */
       like=like*(ea/g2+eb);
    }
    else
    {  /* tp transitional probability */
       /*tp=0.0;
       H1=(1-e)*(1-e)*tp*g1+2*e*(1-e)*g1*g2+e*e*g1*g2;
       H2=(1-e)*(1-e)*g1*g2+2*e*(1-e)*g1*g2+e*e*g1*g2;
       like=like*H1/H2;  */
       like=like*eb;
    }
  }

  /* avoid log of zero */
  if(like < SMALL) return(-9999999);  /* default for not likely to be a match */
  else             return(log(like));
}



