#include "shaza.h"
#include "command.h"
/*************************************************************************************/
double likelihood_ind(i,j,nloci,bit)
/* WARNING: Need to pre-check sample i is subset of ip combination */
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int i;                /* sample          i   */
int j;                /* sample          j   */
int nloci;            /* number of loci      */
unsigned int bit;     /* perm combination ip */
{
   int k;
   int gotalocus;
   double like;

   int m;
   /*double f11,f12;   allele freq first sample (i) */
   double f21,f22;  /* allele freq 2nd sample (j) */
   int k11,k12;     /* allele number first sample (i) */
   int k21,k22;     /* allele number f2nd   sample (j) */

   m=0;           /* testing for first loci combination  */


   /* initialize */
   like=0.0;        /* setting gp to initial value of zero */
   gotalocus=0;   /* need to test if all loci missing    */

   for(k=0; k < nloci; k++ )
                                      /* already tested if animal i is has subset loci in combination ip          */
                                      /* but need to test if animal i may has other loci not in this combination */
   if(locus_missing_bit(k,bit)) /* if locus in this combination                                            */
   {
      gotalocus=1;         /* found a locus with data for this animal */
      k11=animal_data[i][k][0];
      k12=animal_data[i][k][1];
      k21=animal_data[j][k][0];
      k22=animal_data[j][k][1];

      /*f11=binsrch(k,k11);     1st allele frequency of animal i at locus j */
      /*f12=binsrch(k,k12);     2nd allele frequency of animal i at locus j */
      f21=binsrch(k,k21);    /* 1st allele frequency of animal i at locus j */
      f22=binsrch(k,k22);    /* 2nd allele frequency of animal i at locus j */
      /* get likelihood  for individual match */
      like=like_ind(f21,f22,k11,k12,k21,k22,&m);

   }
   if(!gotalocus)
   {
      fprintf(stdout,"\nSee code in:  likelihood_ind() \n\n");
      fprintf(fp7,"\nSee code in:  likelihood_ind() \n\n"); show(bit); exit(1);
      return(-111111113.);   /* likelihood of sample with all loci missing */
   }   
   else            return(like);


}


