#include "shaza.h"
#include "command.h"
/*************************************************************************************/
double likelihood_ind2(model,i,j,nloci,bit)
/* WARNING: Need to pre-check sample i is subset of ip combination */
/* adds errors to comparison */
/* coded by: Michael Macbeth       revision - 29/04/2011     */
/*************************************************************************************/
int model;
int i;                /* sample          i   */
int j;                /* sample          j   */
int nloci;            /* number of loci      */
unsigned int bit;     /* perm combination ip */
{
   int k,kk,jj;
   int gotalocus;
   double like;
   double xx;
   double terror=E_value/10000.0;     /* terrifying error proportion */
   int m;
   /*double f11,f12;   allele freq first sample (i) */
   double f21,f22;      /* allele freq 2nd sample (j) */
   int k11=0,k12=0;     /* allele number first sample (i) */
   int k21=0,k22=0;     /* allele number f2nd   sample (j) */
   int base=1;

   m=0;           /* testing for first loci combination  */

   if((model == 4)||(model == 8)) base=0; /* animal_data is simulated from frequencies */

   /* initialize */
   like=0.0;        /* setting gp to initial value of zero */
   gotalocus=0;   /* need to test if all loci missing    */

   for(k=0; k < nloci; k++ )    /* already tested if animal i is has subset loci in combination ip          */
                                /* but need to test if animal i may has other loci not in this combination */
   if(locus_missing_bit(k,bit)) /* if locus in this combination                                            */
   {
      gotalocus=1;         /* found a locus with data for this animal */

      if(drand() < terror) /* add errors to sample i */
      {
        jj=randchoice();
        xx=drand();
        for(kk=0; kk < loc[k].n; kk++)
        if(xx <= loc[k].cfreq[kk])
        {
          if(base)
          {
            if(jj)
            {
              k11=loc[k].allele[kk];
              k12=animal_data[i][k][1];
            }
            else
            {
              k12=loc[k].allele[kk];
              k11=animal_data[i][k][0];
            }
          }
          else
          {
            if(jj)
            {
              k11=(kk+1);
              k12=animal_data[i][k][1];
            }
            else 
            {
              k12=(kk+1);
              k11=animal_data[i][k][0];
            }
          }
          kk=loc[k].n; /* exit loop */
        }
      }
      else
      {
        k11=animal_data[i][k][0];
        k12=animal_data[i][k][1];
      }

      if(drand() < terror) /* add errors to sample j */
      {
        jj=randchoice();
        xx=drand();
        for(kk=0; kk < loc[k].n; kk++)
        if(xx <= loc[k].cfreq[kk])
        {
          if(base)
          {
            if(jj)
            {
              k21=loc[k].allele[kk];
              k22=animal_data[j][k][1];
            }
            else
            {
              k22=loc[k].allele[kk];
              k21=animal_data[j][k][0];
            }
          }
          else
          {
            if(jj)
            {
              k21=(kk+1);
              k22=animal_data[j][k][1];
            }
            else 
            {
              k22=(kk+1);
              k21=animal_data[j][k][0];
            }
          }
          kk=loc[k].n; /* exit loop */
        }
      }
      else
      {
        k21=animal_data[j][k][0];
        k22=animal_data[j][k][1];
      }


      /*f11=binsrch(k,k11);     1st allele frequency of animal i at locus k */
      /*f12=binsrch(k,k12);     2nd allele frequency of animal i at locus k */
      f21=binsrch(k,k21);    /* 1st allele frequency of animal j at locus k */
      f22=binsrch(k,k22);    /* 2nd allele frequency of animal j at locus k */
      /* get likelihood  for individual match */
      like=like_ind(f21,f22,k11,k12,k21,k22,&m);

   }

   if(!gotalocus)
   {
      fprintf(stdout,"\nSee code in:  likelihood_ind() \n\n");
      fprintf(fp7,"\nSee code in:  likelihood_ind() \n\n"); show(bit); exit(1);
      return(-111111113.);   /* likelihood of sample with all loci missing */
   }   
   else            return(like);


}


