#include "shaza.h"
#include "command.h"
/*************************************************************************************/
double likelihood_inds2(model,i,j,nloci,bit)
/* adds errors to comparison */
/* coded by: Michael Macbeth       revision - 29/04/2011     */
/*************************************************************************************/
int model;
int i;             /* sample          i  */
int j;             /* sample          j  */
int nloci;         /* number of loci */
unsigned int bit;  /* perm combination ip */   /* assumes bit pre-tested to make sure all loci ar enot missing    */
{
   int k,kk,jj;
   double like;
   double xx;
   double terror=E_value/10000.0;     /* terrifying error proportion */
   int base=1;
   int m;
    /* double f11,f12; allele freq first sample (i) */
   double f21,f22;      /* allele freq 2nd sample (j) */
   int k11=0,k12=0;     /* allele number first sample (i) */
   int k21=0,k22=0;     /* allele number f2nd   sample (j) */

   m=0;           /* testing for first loci combination  */

   if((model == 4)||(model == 8)) base=0; /* animal_data is simulated from frequencies */

   /* initialize */
   like=0.0;

   for(k=0; k < nloci; k++ )
   if(locus_missing_bit(k,bit)) /* if locus in this combination */
   {
      if(drand() < terror) /* add errors to sample i */
      {
        jj=randchoice();
        xx=drand();
        for(kk=0; kk < loc[k].n; kk++)
        if(xx <= loc[k].cfreq[kk])
        {
          if(base)
          {
            if(jj)
            {
              k11=loc[k].allele[kk];
              k12=animal_sim[i][k][1];
            }
            else
            {
              k12=loc[k].allele[kk];
              k11=animal_sim[i][k][0];
            }
          }
          else
          {
            if(jj)
            {
              k11=(kk+1);
              k12=animal_sim[i][k][1];
            }
            else 
            {
              k12=(kk+1);
              k11=animal_sim[i][k][0];
            }
          }
          kk=loc[k].n; /* exit loop */
        }
      }
      else
      {
        k11=animal_sim[i][k][0];
        k12=animal_sim[i][k][1];
      }

      if(drand() < terror) /* add errors to sample j */
      {
        jj=randchoice();
        xx=drand();
        for(kk=0; kk < loc[k].n; kk++)
        if(xx <= loc[k].cfreq[kk])
        {
          if(base)
          {
            if(jj)
            {
              k21=loc[k].allele[kk];
              k22=animal_sim[j][k][1];
            }
            else
            {
              k22=loc[k].allele[kk];
              k21=animal_sim[j][k][0];
            }
          }
          else
          {
            if(jj)
            {
              k21=(kk+1);
              k22=animal_sim[j][k][1];
            }
            else 
            {
              k22=(kk+1);
              k21=animal_sim[j][k][0];
            }
          }
          kk=loc[k].n; /* exit loop */
        }
      }
      else
      {
        k21=animal_sim[j][k][0];
        k22=animal_sim[j][k][1];
      }


      /*f11=binsrch(k,k11);     1st allele frequency of animal i at locus j */
      /*f12=binsrch(k,k12);     2nd allele frequency of animal i at locus j */
      f21=binsrch(k,k21);    /* 1st allele frequency of animal i at locus j */
      f22=binsrch(k,k22);    /* 2nd allele frequency of animal i at locus j */

      /* get log likelihood for individual match */
      like=like_ind(f21,f22,k11,k12,k21,k22,&m);

   }

   return(like);  /* returns LLR */
}


