#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void pair_groups(goodPairs,report,ngroup,nlist)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
int goodPairs; /* number of match-pairs below alpha threshold */
int report;
int *ngroup;   /* number of groups of pairwise matches */
int *nlist;    /* all matching animals were placed in one list, the length of this list is *nlist */
/*************************************************************************************/
{
  int i,k;
  int heading=1;
  int igroup=0;
  int ilist=0;

  heading=report; 
 
  /* initialise */    /*  int one_list[PAIRS*2][2]; */
  for(i=0; i< (PAIRS*2); i++) { one_list[i][0]=0; one_list[i][1]=0; }

  /* put pairs in one list */
  for(i=0; i < goodPairs; i++)
  for(k=0; k < 2; k++)
    if(!in_one_list(mat_pairs[1][i].pair[k],ilist)) one_list[ilist++][0]=mat_pairs[1][i].pair[k];

  /* for every sample find matching groups */
  for(i=0; i < ilist; i++)
  {
    if(heading) /* if first record */
    {
      fprintf(fp5,"\n\n");
      fprintf(fp5,"________________________________________________________________________________________________\n");
      fprintf(fp5,"Clustered groups of pairwise matches\n");
      fprintf(fp5,"________________________________________________________________________________________________\n");
      fprintf(fp5,"Group\n");   fflush(fp5);
    }
    heading=0;

    if(used_one_list(one_list[i][0],ilist) == 0)  /* returns 0 for sample not used */
    {
      igroup++;
      if(report) { fprintf(fp5,"\nGP%-4d  %s ",igroup,rec[one_list[i][0]].name);   fflush(fp5); }
      one_list[i][1]=igroup; /* mark as already put in group */
    }

    /* recursive search of groups */
    do_rec_search(i,ilist,goodPairs,report,&igroup);

  } /* i loop */


  *nlist=ilist;
  *ngroup=igroup;
}

