#include "command.h"
#include "shaza.h"
/*************************************************************************************/
void print_genotype_data(nloci,anim,file_name,full,isim,fp_DT)
/* prints in csv format */
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int nloci;       /* number of loci */
int anim;        /* number of genotype samples */
char *file_name; /* holds name of file for writing */
int full;        /* 1 full genotypes reported */
                 /* 0 partial genotypes reported */
int isim;        /* 1 animal_sim[][][] */
                 /* 0 animal_data[][][] */
FILE *fp_DT;     /* file pointer */
{
   int i,j,k;
   

   /* open file for writing */
   if( (fp_DT = fopen(file_name, "w" )) == NULL )
   {
        fprintf(fp7,"print_genotype_data: Cannot open output file %s\n",file_name);
        fprintf(stdout,"print_genotype_data: Cannot open output file %s\n",file_name);
        exit( -1 );
   }

   
   /* write headings to file */
   fprintf(fp_DT,"Record,");
   for(j=0; j < nloci; j++)
   for(k=0; k < PLOID; k++)
   {
      /* fprintf(fp_DT,"L%dA%d,",j+1,k+1);   */
      fprintf(fp_DT,"L%d,",j+1);
   }
   fprintf(fp_DT,"\n");
   
   fprintf(fp_DT,"%s\n",k_value);

   for(i=0; i < anim; i++)
   {
      fprintf(fp_DT,"%5d,",i+1);   /* record number */

      for(j=0; j < nloci; j++)
      for(k=0; k < PLOID; k++)
      {
         if(full)
            if(isim) fprintf(fp_DT,"%d,",animal_sim[i][j][k]);
            else     fprintf(fp_DT,"%d,",animal_data[i][j][k]);
         else
         {
            if(rec[i].mbit&(1<<j))
            {
               if(isim) fprintf(fp_DT,"%d,",animal_sim[i][j][k]);
               else     fprintf(fp_DT,"%d,",animal_data[i][j][k]);
            }
            else                   fprintf(fp_DT,"0,");
         }
      }
      fprintf(fp_DT,"\n");
   }
   fflush(fp_DT);
   fclose(fp_DT);
}


