#include "command.h"
#include "shaza.h"
/*************************************************************************************/
void print_genotype_data_GENEPOP(nloci,anim,file_name,full,isim,fp_DT)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int nloci;       /* number of loci */
int anim;        /* number of genotype samples */
char *file_name; /* holds name of file for writing */
int full;        /* 1 full genotypes reported */
                 /* 0 partial genotypes reported */
int isim;        /* 1 animal_sim[][][] */
                 /* 0 animal_data[][][] */
FILE *fp_DT;     /* file pointer */
{
   int i,j;
   int block;

   /* open file for writing */
   if( (fp_DT = fopen(file_name, "w" )) == NULL )
   {
        fprintf(fp7,"print_genotype_data: Cannot open output file %s\n",file_name);
        fprintf(stdout,"print_genotype_data: Cannot open output file %s\n",file_name);
        exit( -1 );
   }
   
   /* Title line */
   fprintf(fp_DT,"GENEPOP data file created using SHAZA simulation\n");
   
   /* write loci names to file */
   for(j=0; j < (nloci-1); j++)  fprintf(fp_DT,"L%d, ",j+1);
   fprintf(fp_DT,"L%d\n",nloci);

   block=-1;
   for(i=0; i < anim; i++)
   {
      if(rec[i].block != block)
      {
        /* write BLOCK descriptor eg POP */
        fprintf(fp_DT,"%s\n",k_value);
        block=rec[i].block;
      }

      fprintf(fp_DT,"Rec%-5d,",i+1);   /* record number */

      for(j=0; j < nloci; j++)
      {
         if(full)
            if(isim) fprintf(fp_DT," %03d%03d",animal_sim[i][j][0],animal_sim[i][j][1]);
            else     fprintf(fp_DT," %03d%03d",animal_data[i][j][0],animal_data[i][j][1]);
         else
         {
            if(rec[i].mbit&(1<<j)) /* only print partial genotype */
            {
               if(isim) fprintf(fp_DT," %03d%03d",animal_sim[i][j][0],animal_sim[i][j][1]);
               else     fprintf(fp_DT," %03d%03d",animal_data[i][j][0],animal_data[i][j][1]);
            }
            else
            {
                   fprintf(fp_DT," 000000");
            }
         }
      }
      fprintf(fp_DT,"\n");
   }
   fflush(fp_DT);
   fclose(fp_DT);
}



