#include "command.h"
#include "shaza.h"
/*************************************************************************************/
void print_missing_loci(locus,iperm,anim,fp2)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/* Report combinations of missing loci                                               */
/*************************************************************************************/
int locus;
int iperm;
int anim;      /* number of genotype samples */
FILE *fp2;
{
   int ip,j,k;

   /* store missing value combinations */
   /* these missing combinations were defined when reading data */

   if(iperm == 0 ) /* do not create table if there were no missing valuse */
   {
      fprintf(fp2,"\n\nThere were no missing alleles in this data set\n");   fflush(fp2);
   }
   else
   {

      /* headling line */
      fprintf(fp2,"\n\nMissing allele report\n\n");   fflush(fp2);

      for(k=0; k < (4*locus)+28; k++) fprintf(fp2,"_");
      fprintf(fp2,"\n\n              Locus            ");  fflush(fp2);
      for(k=0; k < (4*locus)-14; k++) fprintf(fp2," ");
      fprintf(fp2,"Frequency     \n");  fflush(fp2);

      fprintf(fp2,"            ");
      for(j=1; j<= locus; j++) fprintf(fp2,"%3d ",j);      fflush(fp2);
      fprintf(fp2,"\n");

      for(k=0; k < (4*locus)+28; k++) fprintf(fp2,"_");
      fprintf(fp2,"\nCombination\n");

      /* list of combinations */
      for(ip=0; ip< iperm; ip++)
      {
         fprintf(fp2,"  %5d       ",ip+1);
         bitout2(&perm[ip].bit,locus,fp2);   /* list missing locus combinations */

         fprintf(fp2," %7d \n",perm[ip].n);            fflush(fp2);
      }

      for(k=0; k < (4*locus)+28; k++) fprintf(fp2,"_");

      fprintf(fp2,"\n           ");
      for(k=0; k < ((4*locus)-5); k++) fprintf(fp2," ");
      fprintf(fp2,"Total %10d\n",anim);

      for(k=0; k < (4*locus)+28; k++) fprintf(fp2,"_"); fprintf(fp2,"\n\n\n");
   }
   fflush(fp2);
}

