#include        <math.h>       /* pow sqrt                          */
#include        <time.h>
#include        "shaza.h"      /* for shaza structs and defines etc */
#include        "command.h"      /* for shaza command line        etc */

/*************************************************************************************/
void shaza_pop_report(nBlocks,rBlocks)  /* from simulation data with multiple blocks */
/* coded by: Michael Macbeth       revision - 28/06/2011     */
int nBlocks;         /* number of blocks */
int rBlocks;         /* number of blocks in reference data with a recap */
/*************************************************************************************/

{
   int a;
   int ia,ib;
   double se;
   double sum_vw=0.0;      /* additional variance due to simulating recaptures with whole numbers */

   /* close to open empty file for writing */
   fclose(fp6);
   if( (fp6 = fopen(o_value[3], "w" )) == NULL )   /* SHAZA_pop.txt */
   {
          fprintf( stderr, "open_files(): Cannot open <%s> for writing\n",o_value[3]);
          exit( -1 );
   }

   /* insert Table 1 */
   if( (fp8 = fopen(TEMP_FILE, "r" )) == NULL )   /* SHAZA_pop.txt */
   {
          fprintf( stderr, "shaza_pop_report(): Cannot open <%s> for writing\n",TEMP_FILE);
          exit( -1 );
   }
   while(1)
   {
      a=fgetc(fp8);
      if(!feof(fp8)) fputc(a, fp6);
      else break;
   }
   fclose(fp8);

   /* remove contents of TEMP_FILE */
   remove(TEMP_FILE);




   if(c_value)
   {
   
      if(nBlocks == 1)
      {
   
        fprintf(fp6,"\n\n\n\n\nTable 2  Within population recapture estimate from %d simulation runs\n",s_value);
        fprintf(fp6,"____________________________________________________________________________________________________\n");
        fprintf(fp6,"  Population    Population                 Effective       False       Matches  Recaptures__________\n");
        fprintf(fp6,"  number        size                       sample size     poitives    found    Corrected   \n");
        fprintf(fp6,"  n1            s1                          E               V          M        R_sim       s.e.    \n");
        fprintf(fp6,"____________________________________________________________________________________________________\n");
   
      }
      else
      {
        fprintf(fp6,"\n\n\n\n\nTable 2  Within and between population recapture estimates from %d simulation runs\n",s_value);
        fprintf(fp6,"____________________________________________________________________________________________________\n");
        fprintf(fp6,"  Population    Population    Effective    Effective       False       Matches  Recaptures__________\n");
        fprintf(fp6,"  number        size          block size   sample size     positives   found    Corrected   \n");
        fprintf(fp6,"  n1   n2       s1   s2        b            e               V          M        R_sim       s.e.    \n");
        fprintf(fp6,"____________________________________________________________________________________________________\n");
      }
   
      for(ia=0; ia<nBlocks; ia++)
      for(ib=0; ib<nBlocks; ib++)
   /*   if(sum_rlist[ia][ib] > SMALL) */
      if( ((nBlocks >  1)&&(sum_rlist[ia][ib] > SMALL))||
          ((nBlocks == 1)&&(ngood[0][z_value] > SMALL)) )
      {
        if(nBlocks == 1) se=get_se(ia,ib,rBlocks,Rcor[0][z_value],Rcor[1][z_value],&sum_vw);
        else             se=get_se(ia,ib,rBlocks,sd_corR12[ia][ib][0],sd_corR12[ia][ib][1],&sum_vw);
   
        if(ia == ib)  /* diagonal block */  /* a block is a population by population matrix */
        {
    /*     if(loop == (s_value-1) ) */
           {
             if(nBlocks == 1)
             {
               fprintf(fp6,"%4d        %6d                      %9.2f      %9.3f  %9.2f %9.2f  %9.2f \n",
                               ia+1,
                               (nBlock[ia+1]-nBlock[ia]),
                               Ex[0][z_value]/s_value,  
                               alphaCut[z_value],
                               ngood[0][z_value]/s_value,
                               Rcor[0][z_value]/s_value,            /* average corrected recaps */
                               se
                               );
             }
             else
             {
               fprintf(fp6,"%4d : %-4d %6d : %-6d %9.2f   %9.2f      %9.3f  %9.2f %9.2f  %9.2f\n",
                               ia+1,
                               ib+1,
                               (nBlock[ia+1]-nBlock[ia]),
                               (nBlock[ib+1]-nBlock[ib]),
                               ((nBlock[ib+1]-nBlock[ib])*1.0),
                               sum_E12[ia][ib]/count[ia][ib],          /* need to divide by # times this block combination turned up */
                               sum_A[ia][ib]/count[ia][ib],
                               1.0*sum_rlist[ia][ib]/s_value,
                               sd_corR12[ia][ib][0]/s_value,
                               se        
                               );
             }
           }
        }
        else    /* off-diag block */
        {
           fprintf(fp6,"%4d : %-4d %6d : %-6d %9.2f   %9.2f      %9.3f  %9.2f %9.2f  %9.2f \n",
                           ia+1,
                           ib+1,
                           nBlock[ia+1]-nBlock[ia],               /* sample size (s1)         */
                           nBlock[ib+1]-nBlock[ib],               /* sample size (s2)         */
                           ((1.0*sum_N12[ia][ib])/count[ia][ib]), /* effective block size     */
                           sum_E12[ia][ib]/count[ia][ib],         /* efective sample size (E) */ 
                           sum_A[ia][ib]/count[ia][ib],           /* false positives (V)      */
                           1.0*sum_rlist[ia][ib]/s_value,         /* matches (M)              */
                           sd_corR12[ia][ib][0]/s_value,             /* recaps (R_hat)           */
                           se                                     /* s.e. of matches found    */
                           );
        }
      }
      fprintf(fp6,"____________________________________________________________________________________________________\n");
   
   }
}

