#include <math.h>
#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void simBlockRecaps2(nloci,anim,loop,sum_vw)  /* from simulation data with one block */
/* coded by: Michael Macbeth       revision - 28/6/2011     */
int nloci;           /* number of loci */
int anim;            /* samples in this block */
int loop;            /* iteration number of simulation run */
double *sum_vw;      /* additional variance due to simulating recaptures with whole numbers */
/*************************************************************************************/
{
   double p;                    /* fraction of recapture simulated e.g. if 3.4 recaps simulated p=0.4 */
   double SD_corR12;  /* SD  - standard deviation of simulated recaps */
   double SE_corR12;  /* SE  - standard error of recaps in reference data */
   double skew_cor12;
   double x;
   double vw;

   if(loop == (s_value-1) )  /* if last loop write report */
   {
     fprintf(fp6,"\n\n\n\n\nTable 2  Within population recapture estimate from %d simulation runs\n",s_value);
     fprintf(fp6,"____________________________________________________________________________________________________\n");
     fprintf(fp6,"  Population    Population                 Effective       False       Matches  Recaptures__________\n");
     fprintf(fp6,"  number        size                       sample size     positives   found    Corrected   \n");
     fprintf(fp6,"  n1            s1                          E               V          M        R_sim     s.e.      \n");
     fprintf(fp6,"____________________________________________________________________________________________________\n");

     /* p=fraction of recapture simulated: =0.0 if no recap simulated for ia*ib block */
     /* can only simulate whole numbers of recaptures so round up or down to get average recapture */
     p=simBlock[0].up/(double)s_value;
     vw=s_value*p*(1-p)/(s_value-1);  /* vw=additional variance due to sampling recaptures as whole numbers */
     *sum_vw=*sum_vw+vw;

     if(s_value > 1)
     {   /*          sum(X)           sum(X*X)         sum(X*X*X) */
        skew(s_value,Rcor[0][z_value],Rcor[1][z_value],Rcor[2][z_value],&SD_corR12,&skew_cor12);

        if(p>SMALL)
        {
          if( (x=(SD_corR12*SD_corR12-vw)) > 0)
               SE_corR12=sqrt(x);
          else SE_corR12=0.0; /* by random chance this could occur */
        }
        else   SE_corR12=SD_corR12;
     }
     else
     {
       SD_corR12=0.0;
       skew_cor12=0.0;
       SE_corR12=0.0;
     }


     fprintf(fp6,"%4d        %6d                      %9.2f          %5.3f  %9.2f %9.2f %9.2f \n",
                     1,
                     (nBlock[1]-nBlock[0]),
                     Ex[0][z_value]/s_value,       /* average effective size from total data over s_value simulation runs */
                     alphaCut[z_value],
                     ngood[0][z_value]/s_value,
                     Rcor[0][z_value]/s_value,
                     SE_corR12
                     );

     fprintf(fp6,"____________________________________________________________________________________________________\n");

   }
}


