#include <math.h>
#include "shaza.h"
/*************************************************************************************/
void skew(n,sumX,sumXX,sumXXX,sd,skewness)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int n;            /* sample size */
double sumX;      /* sum X    */
double sumXX;     /* sum X**2 */
double sumXXX;    /* sum X**3 */
double *sd;       /* standard deviation */
double *skewness; /* skewness */
{
   double xx,m2,m3;

   xx=(sumXX-sumX*sumX/n)/(n-1);
   if(xx < SMALL)
   {
      *sd=0.0;
      *skewness=0.0;

   }
   else
   {
      *sd=sqrt(xx);
      m2=(sumXX-(sumX*sumX)/n)/n;
      if(m2 < SMALL)
      {
         *skewness=0.0;   
      }
      else
      {
         m3=(sumXXX-3*sumX*sumXX/n+2*sumX*sumX*sumX/(n*n))/n;
         *skewness=m3/(m2*sqrt(m2));
      }
   }
}

