#include "command.h"
#include "shaza.h"
/*************************************************************************************/
void store_loci_freq(nloci,anim)
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int nloci;   /* number of loci */
int anim;    /* number of genotype samples */
{ 
   int locus;
   int animal_allele[2*ANIM]; /* holds diploid alleles in one vector */
   int i,j,k,m;

   /* initialise */
   for(k=0; k<nloci; k++)
   {
      loc[k].miss=0;
      for(i=0; i<NOA; i++)   loc[k].cfreq[i]=0.0;
   }
   j=2*anim; /* size of animal_allele vector */

   for(locus=0; locus<nloci; locus++)
   {

      /* put allele pairs in one list for sorting */
      for(i=0; i < anim; i++)
      {
         if(rec[i].mbit&(1<<locus)) /* if not missing locus */
         {
            animal_allele[i]=animal_data[i][locus][0];
            animal_allele[i+anim]=animal_data[i][locus][1];
         }
         else
         {
            animal_allele[i]=MISSINGi;
            animal_allele[i+anim]=MISSINGi;
         }
      }

      /* sort allele on its base number */
      qsort(animal_allele,2*anim,sizeof(int),compare_alleles);

      k=1; /* count number of alleles of same type */
      m=0; /* allele types read so far */

      /* count frequency of alleles */
      for(i=1; i < j; i++)
      {
         /* if current allele = previous allele in sorted list */
         if(animal_allele[i] == animal_allele[i-1] )
         {
            k++;
            if((i == (j-1))&&(m < NOA)) /* assign last record */
            {
               loc[locus].count[m]=k;
               loc[locus].allele[m]=animal_allele[i];
               if(animal_allele[i] == MISSINGi)
               {
                  loc[locus].miss=k;
                  loc[locus].freq[m]=0.0;
               }
               else
               {
                  loc[locus].freq[m]=(double)k/(2*anim-loc[locus].miss);
               }

               if(m > 0) loc[locus].cfreq[m]=loc[locus].cfreq[m-1]+loc[locus].freq[m];
               else      loc[locus].cfreq[m]=loc[locus].freq[m];
               m++;
            }
         }
         else   /* new allele */
         {
            /* assign previous record */
            if(m < NOA) /* dont define if matrix bounds exceeded but continue to find max alleles used */
            {
               loc[locus].count[m]=k;
               loc[locus].allele[m]=animal_allele[i-1];
               if(animal_allele[i-1] == MISSINGi)
               {
                  loc[locus].miss=k;
                  loc[locus].freq[m]=0.0;
               }
               else loc[locus].freq[m]=(double)k/(2*anim-loc[locus].miss);

               if(m > 0) loc[locus].cfreq[m]=loc[locus].cfreq[m-1]+loc[locus].freq[m];
               else      loc[locus].cfreq[m]=loc[locus].freq[m];
            }
            m++;
            k=1;

            /* assign last record */
            if(i == (j-1))
            {
               if(m < NOA)
               {
                  loc[locus].count[m]=k;
                  loc[locus].allele[m]=animal_allele[i];
                  if(animal_allele[i] == MISSINGi)
                  {
                     loc[locus].miss=k;
                     loc[locus].freq[m]=0.0;
                  }
                  else loc[locus].freq[m]=(double)k/(2*anim-loc[locus].miss);

                  if(m > 0) loc[locus].cfreq[m]=loc[locus].cfreq[m-1]+loc[locus].freq[m];
                  else      loc[locus].cfreq[m]=loc[locus].freq[m];
               }
               m++;
            }
         }
      }

      loc[locus].n=m;

      if(m++ > NOA)
      {
        fprintf(fp7,"Need to increase allele numbers: change NOA=%d to new value of %d and recomplie\n",NOA,m);
        fprintf(stdout,"Need to increase allele numbers: change NOA=%d to new value of %d and recompile\n",NOA,m);
        exit(1);
      }

   } /* for locus */
}

