
#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void store_match_pairs(nrec,i,j,ia,ib,x,bit,isim) /* record match statistics   */
/* coded by: Michael Macbeth       revision - 5/10/2009     */
/*************************************************************************************/
int nrec;         /* record number of match */
int i;            /* first  allele sample record number */
int j;            /* second allele sample record number */
int ia;           /* position of group a (using 0 as first block) */
int ib;           /* position of group b (using 0 as first block) */
double x;         /* likelihood */
unsigned int bit; /* bit-wise missing loci combination  */
int isim;         /* =0 for real data else =1 for simulation */
{
    if((nrec+1) >PAIRS)
    {
      fprintf(fp7,"\nNeed to increase variable PAIRS to hold pairwise matches (nrec+1=%d)> PAIRS\n",nrec);
      fprintf(fp7,"Alternatively increase MAX_RANK which will reduce the number of pairs recorded in your dataset\n");
      fprintf(stdout,"\nNeed to increase variable PAIRS to hold pairwise matches (nrec+1=%d)> PAIRS\n",nrec);
      fprintf(stdout,"Alternatively increase MAX_RANK which will reduce the number of pairs recorded in your dataset\n");
      exit(1);
    }

    mat_pairs[isim][nrec].LLR=x;
    mat_pairs[isim][nrec].pair[0]=i;
    mat_pairs[isim][nrec].pair[1]=j;
    mat_pairs[isim][nrec].block[0]=ia+1;  /* block number from 1..n */
    mat_pairs[isim][nrec].block[1]=ib+1;  /* block number from 1..n */
    mat_pairs[isim][nrec].bit=bit;
}


