#include "shaza.h"
#include "command.h"
/*************************************************************************************/
void write_composites(nloci,anim,nlist,ngroup,animal_comp)
/* coded by: Michael Macbeth       revision - 26/05/2011     */
/*************************************************************************************/
int nloci;           /* number of loci */
int anim;            /* number of genotype samples */
int nlist;           /* number of unique samples across all pair-wise matches */
int ngroup;          /* number of groups with no matches between them */
int ***animal_comp;  /* three dimensional array holding composite groups */
/* BUGFIX: reads from ainal_data */
{
   int i,k;
   FILE *fp_GT;     /* file pointer */

   /* open file for writing */
   if( (fp_GT = fopen(o_value[6], "w" )) == NULL )
   {
        fprintf(fp7,"write_composites: Cannot open output file %s\n",o_value[6]);
        fprintf(stdout,"write_composites: Cannot open output file %s\n",o_value[6]);
        exit( -1 );
   }

   
   /* Title line */
   fprintf(fp_GT,"GENEPOP data file created using SHAZA simulation\n");
   
   /* write loci names to file */
   for(k=0; k < (nloci-1); k++)  fprintf(fp_GT,"L%d, ",k+1);
   fprintf(fp_GT,"L%d\n",nloci);

   /* write BLOCK descriptor eg POP */
   fprintf(fp_GT,"%s\n",k_value);

   /* write composite genotypes */
   for(i=0; i<ngroup; i++)
   {
     fprintf(fp_GT,"GP%-13d,",i+1);  /* sample number */

     for(k=0; k<nloci; k++)    fprintf(fp_GT," %03d%03d",animal_comp[i][k][0],animal_comp[i][k][1]);
     fprintf(fp_GT,"\n");
   }

   /* write genotypes not included in composites */
   for(i=0; i < anim; i++)
   if(!in_one_list(i,nlist))
   {
      fprintf(fp_GT,"%-15s,",rec[i].name);    /* sample number */
      /*for(k=0; k < nloci; k++) fprintf(fp_GT," %03d%03d",animal_sim[i][k][0],animal_sim[i][k][1]); */
      for(k=0; k < nloci; k++) fprintf(fp_GT," %03d%03d",animal_data[i][k][0],animal_data[i][k][1]);
      fprintf(fp_GT,"\n");
   }
   fflush(fp_GT);
   fclose(fp_GT);
}


