#include "shaza.h"
#include "command.h"

/*************************************************************************************/
void write_loci_freq(nloci,anim,model)
/* coded by: Michael Macbeth       revision - 5/10/2009                              */
/* writes allele frequencies read from empiracle allele data                         */
/*************************************************************************************/
int nloci;     /* number of loci */
int anim;      /* number of genotype samples */
int model;
{
   int i,j,n;

   int ok2=1;
   
   fprintf(fp1,"\n\n\n_________________________________________________________________________________\n\n");
   if((model == 1)||(model == 3)||(model == 5)||(model == 7)||(model == 9))
     fprintf(fp1,"Allele frequencies of %d records read from file <%s> \n",anim,i_value[0]);
   else if((model == 2)||(model == 4)|(model == 6)||(model == 8)||(model == 10))
     fprintf(fp1,"Allele frequencies read from file: <%s>\n\n",i_value[1]);
   else
     fprintf(fp1,"Allele frequencies read from dunno\n\n");
   fprintf(fp1,"_________________________________________________________________________________\n\n");

   for(i=0; i < nloci; i++)           /* loci   */
   {
      n=1;
      fprintf(fp1,"    loci          loci      allele     allele     allele  allele       cumulative'n  \n");
      fprintf(fp1,"    name          number    name       number     count   frequency    frequency\n\n");
      for(j=0; j < loc[i].n; j++) /* allele */
      {
         if(loc[i].allele[j] == MISSINGi)
         {
            fprintf(fp1,"%10s  %10d         M           0", loc[i].name, i+1);
            fprintf(fp1,"%10d        -            -", loc[i].count[j] );

            if( loc[i].n == 1 )  { fprintf(fp1,"\n\nWARNING: This locus only had missing values\n\n"); ok2=0; }
         }
         else
         {
            fprintf(fp1,"%10s  %10d %10d %10d", loc[i].name, i+1, loc[i].allele[j],n++);
            fprintf(fp1,"%10d  %10.5f   %10.5f ", loc[i].count[j], loc[i].freq[j], loc[i].cfreq[j] );
         }

         if(j < loc[i].n-1) fprintf(fp1,"\n");
      }

      if(( loc[i].cfreq[loc[i].n-1]  > 1.+TOL)||( loc[i].cfreq[loc[i].n-1] < 1.-TOL))
         fprintf(fp1,"WARNING: Allele frequencies do not add up to one: freq=%12.9f \n",loc[i].cfreq[loc[i].n-1]);
      fprintf(fp1,"\n\n\n");

   }

   fprintf(fp1,"_________________________________________________________________________________\n\n");

   if(!ok2)
   {
      fprintf(fp7,"\n\nSTOPPING RUN: Due to all alleles in at least one loci having all missing values \n\n");
      fprintf(stdout,"\n\nSTOPPING RUN: Due to all alleles in at least one loci having all missing values \n\n");
      exit(1);
   }

}
