#include "shaza.h"
#include "command.h"


/*************************************************************************************/
void z_converge_note(nn,zv)
/* coded by: Michael Macbeth       revision - 28/06/2011     */
int nn;  /* if last convergence iteration was best estimate */
int zv;  /* converged [-z NUM ] value */
/*************************************************************************************/
{

  z_converge_note2(fp3,nn,zv,0);  /* SHAZA_stat.txt */
  z_converge_note2(fp7,nn,zv,0);  /* SHAZA_log.txt */
  z_converge_note2(stdout,nn,zv,0); 
}

/*************************************************************************************/
void z_converge_note2(file_ptr,nn,zv,shortn)
FILE *file_ptr;
int nn;  /* if last convergence iteration was best estimate */
int zv;  /* converged [-z NUM ] value */
int shortn; /* short note */
/*************************************************************************************/
{
  int zv2=0;
  int add=0;
  int k;
  int kMin=-1;

  if(n_value != 1000) add=1;
  zv2=zv+add;

  fprintf(file_ptr,"\n\nNOTE:   Convergence found with '-z %2d' (V=%5.3f false positives)\n",zv2,alphaCut[zv]);


  if(!shortn)
  {
     /* find Rcor estimate with smallest s.d. */
     for(k=0; k <RANK_SFZ; k++)
     {
       if((kMin < 0)&&(Rse[0][k] > 0.0)) kMin=k;
       else if((Rse[0][k] < Rse[0][kMin])&&(Rse[0][k] > 0.0)) kMin=k;
     }
   
     fprintf(file_ptr,"\n\n____________________________________________________________ \n");
     fprintf(file_ptr,"Convergence summary of total corrected recaptures (R_hat)        \n");
     fprintf(file_ptr,"____________________________________________________________ \n");
     fprintf(file_ptr,"                    Reference       Simulated   \n");
     fprintf(file_ptr,"                    data            data        \n");
     fprintf(file_ptr,"____________________________________________________________ \n");
     fprintf(file_ptr," -z      False      R_hat           R_hat   s.e. \n");
     fprintf(file_ptr,"         positives                               \n");
     fprintf(file_ptr,"____________________________________________________________ \n");
     for(k=0; k <RANK_SFZ; k++)
     if(Rse[0][k] > 0.0 ) /* if this z_value done before */
     {
       if(n_value != 1000) zv2=k+1;
       else zv2=k;
   
//       fprintf(file_ptr,"%3d  %10.3f %10.3f      %10.3f %6.3f",zv2,alphaCut[k],Rse[2][k],Rse[1][k],Rse[0][k]); 
       fprintf(file_ptr,"%3d  %10.3f %10.3f      %10.3f %6.3f",zv2,alphaCut[k],d_Rcor[k],Rse[1][k],Rse[0][k]); 
       if(kMin == k) fprintf(file_ptr," (min s.e.)\n");
       else          fprintf(file_ptr,"\n");
       
     }
     fprintf(file_ptr,"____________________________________________________________ \n");
  }

}

